$chip(6502)
$title(Impossible Mission II)
$subtitle(Build the Room Table)
$paginate
$indent=8

**********************************************
*					     *
*					     *
*					     *
**********************************************

	%include macro.inc
	%include prmseg.inc
	%include matrix.inc

	EXTERN	rd_main, wr_main, rd_aux, wr_aux, scanhi, scanlo
	
	EXTERN	x_pos, y_pos, length
	EXTERN	holes,bombtime
	EXTERN	n_lifts, lifts, MAXPOS

	extern	prmsec,darken
	extern	build1
	EXTERN	chart
	EXTERN	putlift

	extern	furnsiz,n_objects,objects,maxobjects
	extern	spdefs,xsppoint,xdraw

ltype	equ	2
c_pos	equ	8
n_pos	equ	7
v_pos	equ	9

	PUBLIC	build,erasobj,drkflg

	seg	page0

	single	x1
	single	x2
	single	y1
	single	y2
	single	objtmp
	single	count
	double	ptr2
	single	cnt2

	single	xpos
	single	ypos
	single	offset
	single	dist

	single	drkflg
	
	SEG	temps

	double	point

	single	spxofs
	single	spyofs
	single	len
	single	hght
	single	depth
	single	tempy
	single	loop
	single	fndflg
	
	SEG	maincode

**********************************************
*		Set-up			     *
**********************************************

build	PROC

	lda	#$ff		;rebuilding explodes bomb
	sta	bombtime

	long	prmsec,build1
*** All of the other Screen stuff ***
	lda	drkflg
	bne	nocht
	jsr	chart
nocht	jsr	allifts

	lda	drkflg
	beq	noblk
	long	prmsec,darken
noblk
*********************************************
*	searchable objects
*********************************************

	move	count,n_objects
	lbeq	..enobj
	ldx	#0

..olp10
	lda	objects+3,x	;object time
	beq	..objsk
	lda	drkflg
	beq	noblk2
	lda	objects+2,x
	cmp	#2
	beq	noblk2
	cmp	#3
	beq	noblk2
	jmp	..objsk
noblk2
	lda	objects+x_pos,x
	sta	x1
	asl	a
;the below code positions them to look best, but lifts can erase the left
;part of a few objects, so is commented out.
;	sec
;	sbc	#1
	sta	spxofs

	lda	objects+y_pos,x
	sta	y1

	lda	objects+2,x
	asl	a
	tay

	sta	rd_aux
	sta	wr_aux
	lda	spdefs,y
	sta	xsppoint
	lda	spdefs+1,y
	sta	xsppoint+1
	sta	rd_main
	sta	wr_main

	lda	furnsiz,y
	clc
	adc	x1
	sta	x2
	lda	y1
	sec
	sbc	furnsiz+1,y
	sta	y2
	clc
	adc	#1
	asl	a
	asl	a
	asl	a
	sta	spyofs
	stx	cnt2
	jsr	objmask
	ldx	spxofs
	ldy	spyofs
	sta	rd_main
	sta	wr_main
	long	prmsec,xdraw
	sta	rd_main
	ldx	cnt2
..objsk inx
	inx
	inx
	inx
	inx
	dec	count
	lbne	..olp10

..enobj
**********************************************
*	Bombs
**********************************************
	public	buibom
	
	lda	#8
	sta	count
	ldx	#0

	extern	nxpcc,bmbimg

..loop4y
	sta	rd_aux
	sta	wr_aux
	lda	holes,x
	lbeq	..nxbmb
buibom
	cmp	#1
	beq	..dobmb
	cmp	#4
	lbne	..nxbmb
..dobmb
	sta	len
	sta	nxpcc+2
	
	lda	holes+1,x
	asl	a
	sec
	sbc	#5
	sta	nxpcc

	lda	holes+2,x
	asl	a
	asl	a
	asl	a
	tay
	sec
	sbc	#1
	sta	nxpcc+1
	
	lda	scanlo,y
	sta	point
	lda	scanhi,y
	clc
	adc	#$04
	sta	point+1

	ldy	holes+1,x	;get x

	sta	rd_main
	sta	wr_main
	lda	(point),y
	ora	#$20
	and	#$bf
	sta	(point),y
	lda	len
	cmp	#4
	bne	..bmxit
	lda	(point),y
	ora	#$40
	sta	(point),y
..bmxit
	sta	rd_aux
	sta	wr_aux

	stx	cnt2

	lda	#$e6
	sta	nxpcc+3
	lda	#low(bmbimg)
	sta	nxpcc+4
	lda	#high(bmbimg)
	sta	nxpcc+5
	lda	#low nxpcc
	sta	xsppoint
	lda	#high nxpcc
	sta	xsppoint+1

	sta	rd_main
	sta	wr_main
	ldy	#0
	ldx	#0
	long	prmsec,xdraw

	ldx	cnt2

..nxbmb sta	rd_main
	sta	wr_main
	inx
	inx
	inx
	dec	count
	lbne	..loop4y

	rts

build	ENDPROC

*********************************************
*	delete searchable objects
*	X and Y pass the location of the object
*********************************************
erasobj	proc
	lda	#$ff
	sta	objtmp
	sta	wr_main
	txa
	lsr	a
	sta	x1
	tya			;location of floor
	sta	y1
	inc	y1
	lda	#5
	sta	y2
..vtlp	lda	y1
	adc	#4
	and	#$f8
	sta	cnt2
	tay
	sta	rd_aux
	lda	scanlo,y	;get scan location
	sta	ptr2
	lda	scanhi,y
	sta	rd_main
	clc
	adc	#$04		;convert for lookup table
	sta	ptr2+1
	ldy	x1

	lda	(ptr2),y 	;clear object bit
	and	#$bf
	sta	(ptr2),y
	lda	y1
	sec
	sbc	#8
	sta	y1
	dec	y2
	bne	..vtlp

	move	count,n_objects
	lbeq	..enobj
	ldx	#0

..olp10
	lda	objects+3,x
	beq	xfnd3			;don't process already searched

	lda	drkflg
	beq	xfndxx
	lda	objects+2,x
	cmp	#2
	beq	xfndxx
	cmp	#3
	beq	xfndxx
	jmp	xfnd3

xfndxx
	lda	objects+x_pos,x		;set X and Y
	sta	x1
	lda	objects+y_pos,x
	sta	y1
	lda	objects+2,x
	asl	a
	tay
	lda	furnsiz,y		;get W and H
	clc
	adc	x1
	sta	x2
	lda	y1
	sec
	sbc	furnsiz+1,y
	sta	y2
	stx	cnt2
	lda	#0
	sta	fndflg
	jsr	objmask			;test (and reset) object
	lda	fndflg
	bne	xfnd1
xfnd2	ldx	cnt2
xfnd3	inx
	inx
	inx
	inx
	inx
	dec	count
	lbne	..olp10
..enobj lda	objtmp
	rts

xfnd1
	ldx	#0
	lda	cnt2
	beq	gtsk
gtlp	inx
	sec
	sbc	#5
	bne	gtlp
gtsk	stx	objtmp
	jmp	xfnd2

	ENDPROC

**************************************************************************
*	Create masks where objects go (and detect if newly set)
**************************************************************************
objmask	PROC
..vrtlp
	lda	y1		;location of floor
	asl	a
	asl	a
	asl	a
	tay
	sta	rd_aux
	lda	scanlo,y	;get scan location
	sta	ptr2
	lda	scanhi,y
	sta	rd_main
	clc
	adc	#$04		;convert for lookup table
	sta	ptr2+1
	ldy	x1
..hzlp
	lda	(ptr2),y
	and	#$40
	bne	..contfnd
	
	lda	(ptr2),y		;fill hole in for now
	ora	#$40
	sta	(ptr2),y
	lda	#1
	sta	fndflg
	
..contfnd
	iny
	cpy	x2
	bne	..hzlp		;repeat for rest of floor
	dec	y1
	lda	y1
	cmp	y2
	bne	..vrtlp
	rts
objmask	ENDPROC

allifts PROC

	move	count,n_lifts
	beq	..done
	move	offset,#0

..loopl ldx	offset
	lda	lifts+4,x
	sta	cnt2
	lda	lifts+y_pos,x
	sec
	sbc	#1
	sta	ypos
	lda	lifts+x_pos,x
	sta	xpos
	lda	lifts+5,x
	sta	dist

..loopk ldy	ypos
	ldx	xpos
	jsr	putlift
	dec	cnt2
	beq	..nxlft

	lda	ypos
	clc
	adc	dist
	sta	ypos
	jmp	..loopk

..nxlft add	offset,13+MAXPOS
	dec	count
	bne	..loopl

..done	rts

allifts ENDPROC

	END
