$chip(6502)
$title(Impossible Mission 2)
$paginate
$indent=8
**********************************************
*					     *
*	      Main code 		     *
*					     *
**********************************************

	%include macro.inc
	%include secseg.inc

	EXTERN	wr_main, wr_aux, rd_main, rd_aux
	EXTERN	scanlo,scanhi	     ;used to find collisions

	PUBLIC	corribui,leftwal,rghtwal, pt1, pt2

	SEG	PAGE0

	single	cortmp
	single	pt1
	single	pt2

	SEG	graph

**************************************************************************
*	BUILD CORRIDOR COLLISION TABLE
**************************************************************************

corribui	PROC

	lda	#0		;clear out collision screen
	tax
..loop1 sta	$400,x		;copied from BUILD.ASM
	sta	$500,x		;clears out sections of memory
	sta	$600,x		;corresponding to the collsion table
	sta	$700,x
	inx
	bne	..loop1

	ldy	#$48		;location of floor
	sta	rd_aux
	lda	scanlo,y	;get scan location
	sta	pt1
	lda	scanhi,y
	sta	rd_main
	clc
	adc	#$04		;convert for lookup table
	sta	pt1+1
	ldy	#39
	lda	#$80		;code for solid
flrlp	sta	(pt1),y       ;set character
	dey
	bpl	flrlp		;repeat for rest of floor

	ldy	#20		;set onlift for in elevator areas
	lda	#$c0
	sta	(pt1),y
	dey
	sta	(pt1),y

	rts
corribui	ENDPROC

;-------------------------------------------------------------------------
;Build left wall
leftwal	PROC
	lda	#$50		;now add walls
	sta	cortmp

..loop2 lda	cortmp
	sec
	sbc	#8		;move up
	sta	cortmp
	cmp	#$18
	beq	..nxwal
	tay
	sta	rd_aux
	lda	scanlo,y	;lookup location to set
	sta	pt1
	lda	scanhi,y
	sta	rd_main
	clc
	adc	#$04
	sta	pt1+1

	ldy	#17		;left wall
	lda	#$80
	sta	(pt1),y
	jmp	..loop2
..nxwal
	rts
leftwal	ENDPROC

;-------------------------------------------------------------------------
;Build right wall
rghtwal	PROC
	lda	#$50		;now add walls
	sta	cortmp

..loop2 lda	cortmp
	sec
	sbc	#8		;move up
	sta	cortmp
	cmp	#$18
	beq	..nxwal
	tay
	sta	rd_aux
	lda	scanlo,y	;lookup location to set
	sta	pt1
	lda	scanhi,y
	sta	rd_main
	clc
	adc	#$04
	sta	pt1+1

	lda	#$80
	ldy	#22		;right wall
	sta	(pt1),y

	jmp	..loop2
..nxwal
	rts
rghtwal	ENDPROC

	END

