$chip(6502)
$title(Impossible Mission 2)
$subtitle(Animation definitions)
$paginate
$indent=8

	PUBLIC	tablee,staani,disbuf,disbuf1
	%include auxseg.inc
	SEG	spdata

;structure is as follows: light image index, dark image index, Y height above
; floor, Y displacement of light from dark scan line, delta-x for animation
; collision info, TBD, next image in animation (if no state transition)
;	collision bitmap: can't fall/?/forward barrier(top->bot)
;frame 0 is standing
staani	db	0,  1,28, 1,0,$0f,0,0	  ;1/15/27/30
;frame 1 starts run animation
	db	16, 2,28, 1,1,$0f,0,2
	db	17, 3,28, 1,1,$0f,0,3
	db	18, 4,28, 1,2,$8f,0,4
	db	19, 5,29, 1,2,$8e,0,5
	db	20, 6,30, 1,1,$8e,0,6
	db	21, 7,31, 1,1,$8e,0,7
	db	22, 8,28, 1,1,$8f,0,8
;frame 8 is other half of run (different light, same dark sprites)
	db	16, 9,28, 1,1,$0f,0,9
	db	17,10,28, 1,1,$0f,0,10
	db	18,11,28, 1,2,$8f,0,11
	db	19,12,29, 1,2,$8e,0,12
	db	20,13,30, 1,1,$8e,0,13
	db	21,14,31, 1,1,$8e,0,14
	db	22,15,28, 1,1,$8f,0,1
;frame 15 starts jump animation
	db	23,35,30, 1, 1, $8f,0,16
	db	24,36,32, 1, 2, $87,0,17
	db	25,37,34, 6, 2, $8e,0,18	;2
	db	26,38,35, 6, 2, $8e,0,19
	db	27,39,35, 6, 2, $9c,0,20	;2
	db	28,40,36, 5, 2, $9c,0,21
	db	29,41,36, 3, 1, $98,0,22		;were $90,$90
	db	30,42,35, 0, 2, $98,0,23
	db	31,43,35,-3, 2, $9c,0,24
	db	32,44,34, 0, 2, $9e,0,25
	db	33,45,32, 0, 2, $8e,0,26
	db	34,46,30, 1, 1, $0f,0,0
;frame 27 starts squat
	db	47,50,26, 1,0,$0f,0,28 ;/0
	db	48,51,23, 1,0,$07,0,29 ;/27
	db	49,52,21, 1,0,$07,0,29 ;/28
;frame 30 is searching
	db	53,54,29, 4,0,$0f,0,0
;dummy end of table
	db	 0, 0, 0, 0,0,	0,0,0

;table of pointers to the beginning of images
tablee	dw	stand
	dw	standw
	dw	run01w
	dw	run02w
	dw	run03w
	dw	run04w
	dw	run05w
	dw	run06w
	dw	run07w
	dw	run08w

	dw	run09w
	dw	run10w
	dw	run11w
	dw	run12w
	dw	run13w
	dw	run14w
	dw	run01
	dw	run02
	dw	run03
	dw	run04

	dw	run05
	dw	run06
	dw	run07
	dw	jump01
	dw	jump02
	dw	jump03
	dw	jump04
	dw	jump05
	dw	jump06
	dw	jump07

	dw	jump08
	dw	jump09
	dw	jump10
	dw	jump11
	dw	jump12
	dw	jump01w
	dw	jump02w
	dw	jump03w
	dw	jump04w
	dw	jump05w

	dw	jump06w
	dw	jump07w
	dw	jump08w
	dw	jump09w
	dw	jump10w
	dw	jump11w
	dw	jump12w
	dw	squat01
	dw	squat02
	dw	squat03

	dw	squat01w
	dw	squat02w
	dw	squat03w
	dw	search
	dw	searchw
	dw	0

;The actual images.  Normally light images are suffixed with a w
stand	db	28
	db	$06, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$00, $00
	db	$0c, $00
	db	$04, $00
	db	$04, $00
	db	$04, $00
	db	$04, $00
	db	$04, $00
	db	$00, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$1c, $00
	db	$1e, $00
	db	$0e, $00
	db	$0f, $00
	db	$1b, $00
	db	$1b, $00
	db	$12, $00
	db	$12, $00
	db	$36, $00
	db	$24, $00
	db	$24, $00
	db	$24, $00
	db	$36, $00

standw	db	14
	db	$06, $00
	db	$06, $00
	db	$06, $00
	db	$04, $00
	db	$00, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$0c, $00
	db	$06, $00
	db	$03, $00
	db	$01, $00

run01	db	28
	db	$06, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$00, $00
	db	$04, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$24, $00
	db	$36, $00
	db	$0e, $00
	db	$0c, $00
	db	$08, $00
	db	$18, $00
	db	$10, $00
	db	$20, $00
	db	$20, $00
	db	$30, $00

run02	db	28
	db	$0c, $00
	db	$10, $00
	db	$10, $00
	db	$10, $00
	db	$00, $00
	db	$08, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$1c, $00
	db	$1c, $00
	db	$0e, $00
	db	$0e, $00
	db	$0b, $00
	db	$0b, $00
	db	$0e, $00
	db	$1c, $00
	db	$38, $00
	db	$30, $00
	db	$60, $00
	db	$40, $00
	db	$40, $00
	db	$60, $00

run03	db	28
	db	$06, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$00, $00
	db	$04, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$1c, $00
	db	$1c, $00
	db	$1e, $00
	db	$1e, $00
	db	$17, $00
	db	$33, $00
	db	$32, $00
	db	$62, $00
	db	$62, $00
	db	$44, $00
	db	$44, $01
	db	$04, $01
	db	$06, $03
	db	$00, $02
	db	$00, $03

run04	db	27
	db	$0c, $00
	db	$10, $00
	db	$10, $00
	db	$10, $00
	db	$00, $00
	db	$08, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$1c, $00
	db	$1e, $00
	db	$1e, $00
	db	$37, $00
	db	$31, $00
	db	$61, $00
	db	$42, $01
	db	$02, $03
	db	$02, $06
	db	$02, $04
	db	$02, $04
	db	$03, $00

run05	db	28
	db	$0c, $00
	db	$10, $00
	db	$10, $00
	db	$10, $00
	db	$00, $00
	db	$08, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$38, $00
	db	$38, $00
	db	$38, $00
	db	$2c, $00
	db	$2c, $00
	db	$24, $00
	db	$66, $07
	db	$66, $07
	db	$02, $04
	db	$02, $00
	db	$02, $00
	db	$02, $00
	db	$02, $00
	db	$03, $00

run06	db	28
	db	$0c, $00
	db	$10, $00
	db	$10, $00
	db	$10, $00
	db	$00, $00
	db	$08, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $02
	db	$1c, $03
	db	$54, $07
	db	$74, $00
	db	$34, $00
	db	$14, $00
	db	$06, $00
	db	$02, $00
	db	$02, $00
	db	$02, $00
	db	$03, $00

run07	db	27
	db	$03, $00
	db	$04, $00
	db	$04, $00
	db	$04, $00
	db	$00, $00
	db	$02, $00
	db	$06, $00
	db	$06, $00
	db	$06, $00
	db	$06, $00
	db	$06, $00
	db	$06, $00
	db	$06, $00
	db	$06, $00
	db	$06, $00
	db	$26, $00
	db	$36, $00
	db	$3a, $00
	db	$0f, $00
	db	$07, $00
	db	$03, $00
	db	$01, $00
	db	$01, $00
	db	$02, $00
	db	$02, $00
	db	$02, $00
	db	$03, $00

run01w	db	11
	db	$06, $00
	db	$06, $00
	db	$06, $00
	db	$04, $00
	db	$00, $00
	db	$08, $00
	db	$18, $00
	db	$10, $00
	db	$30, $00
	db	$23, $00
	db	$23, $00

run02w	db	13
	db	$0C, $00
	db	$0C, $00
	db	$0C, $00
	db	$08, $00
	db	$00, $00
	db	$10, $00
	db	$30, $00
	db	$22, $00
	db	$66, $00
	db	$44, $00
	db	$40, $00
	db	$40, $00
	db	$40, $00

run03w	db	12
	db	$06, $00
	db	$06, $00
	db	$06, $00
	db	$04, $00
	db	$00, $00
	db	$09, $00
	db	$19, $00
	db	$12, $00
	db	$22, $00
	db	$20, $00
	db	$10, $00
	db	$10, $00

run04w	db	13
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$08, $00
	db	$00, $00
	db	$12, $00
	db	$14, $00
	db	$24, $00
	db	$20, $00
	db	$20, $00
	db	$10, $00
	db	$10, $00
	db	$10, $00

run05w	db	13
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$08, $00
	db	$00, $00
	db	$14, $00
	db	$14, $00
	db	$20, $00
	db	$20, $00
	db	$20, $00
	db	$10, $00
	db	$18, $00
	db	$08, $00

run06w	db	13
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$08, $00
	db	$00, $00
	db	$10, $00
	db	$10, $00
	db	$20, $00
	db	$24, $00
	db	$20, $00
	db	$10, $00
	db	$18, $00
	db	$0c, $00

run07w	db	11
	db	$03, $00
	db	$03, $00
	db	$03, $00
	db	$02, $00
	db	$00, $00
	db	$04, $00
	db	$04, $00
	db	$04, $00
	db	$04, $00
	db	$04, $00
	db	$07, $00

run08w	db	10
	db	$06, $00
	db	$06, $00
	db	$06, $00
	db	$04, $00
	db	$00, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$0b, $00
	db	$0c, $00

run09w	db	10
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$08, $00
	db	$00, $00
	db	$10, $00
	db	$10, $00
	db	$1a, $00
	db	$0c, $00
	db	$08, $00

run10w	db	11
	db	$06, $00
	db	$06, $00
	db	$06, $00
	db	$04, $00
	db	$00, $00
	db	$08, $00
	db	$09, $00
	db	$0a, $00
	db	$0a, $00
	db	$0c, $00
	db	$04, $00

run11w	db	11
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$08, $00
	db	$00, $00
	db	$10, $00
	db	$10, $00
	db	$14, $00
	db	$14, $00
	db	$18, $00
	db	$18, $00

run12w	db	11
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$08, $00
	db	$00, $00
	db	$10, $00
	db	$10, $00
	db	$24, $00
	db	$2c, $00
	db	$38, $00
	db	$30, $00

run13w	db	12
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$08, $00
	db	$00, $00
	db	$10, $00
	db	$10, $00
	db	$10, $00
	db	$20, $00
	db	$20, $00
	db	$38, $00
	db	$20, $00

run14w	db	13
	db	$03, $00
	db	$03, $00
	db	$03, $00
	db	$02, $00
	db	$00, $00
	db	$04, $00
	db	$04, $00
	db	$0c, $00
	db	$08, $00
	db	$19, $00
	db	$18, $00
	db	$0c, $00
	db	$06, $00

jump01	db	21
	db	$07, $00
	db	$19, $00
	db	$31, $00
	db	$71, $00
	db	$60, $00
	db	$60, $01
	db	$40, $01
	db	$40, $01
	db	$40, $01
	db	$40, $01
	db	$40, $01
	db	$40, $01
	db	$40, $01
	db	$40, $03
	db	$40, $02
	db	$40, $06
	db	$40, $04
	db	$40, $0c
	db	$40, $08
	db	$60, $08
	db	$00, $04

jump01w db	9
	db	$06, $00
	db	$0e, $00
	db	$0e, $00
	db	$0c, $00
	db	$06, $00
	db	$02, $00
	db	$02, $00
	db	$01, $00
	db	$01, $00

jump02
	db	$12
	db	$7a, $00
	db	$73, $01
	db	$71, $01
	db	$41, $01
	db	$41, $01
	db	$42, $01
	db	$40, $01
	db	$40, $01
	db	$40, $01
	db	$40, $01
	db	$40, $00
	db	$40, $00
	db	$40, $00
	db	$40, $00
	db	$40, $00
	db	$40, $00
	db	$40, $00
	db	$60, $00

jump02w db	$08
	db	$0c, $00
	db	$0e, $00
	db	$0e, $00
	db	$0a, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00

jump03	db	$14
	db	$18, $00
	db	$1c, $00
	db	$3c, $00
	db	$3e, $00
	db	$36, $00
	db	$36, $00
	db	$36, $00
	db	$31, $00
	db	$31, $00
	db	$31, $00
	db	$21, $00
	db	$00, $00
	db	$00, $00
	db	$60, $00
	db	$40, $00
	db	$40, $01
	db	$00, $01
	db	$00, $01
	db	$00, $01
	db	$40, $00

jump03w db	$06
	db	$06, $00
	db	$06, $00
	db	$0e, $00
	db	$1a, $00
	db	$30, $00
	db	$20, $00

jump04	db	$0c
	db	$18, $00
	db	$1c, $00
	db	$1e, $00
	db	$1e, $00
	db	$16, $00
	db	$16, $04
	db	$00, $0e
	db	$01, $0b
	db	$71, $01
	db	$21, $00
	db	$01, $00
	db	$06, $00

jump04w db	$05
	db	$3e, $00
	db	$3e, $00
	db	$02, $00
	db	$06, $00
	db	$06, $00

jump05	db	$10
	db	$00, $01
	db	$44, $01
	db	$4c, $02
	db	$4e, $00
	db	$6e, $00
	db	$2e, $00
	db	$07, $00
	db	$07, $00
	db	$33, $00
	db	$1a, $00
	db	$1e, $00
	db	$10, $00
	db	$02, $00
	db	$02, $00
	db	$06, $00
	db	$0e, $00

jump05w db	$09
	db	$78, $00
	db	$38, $00
	db	$0c, $00
	db	$04, $00
	db	$00, $00
	db	$04, $00
	db	$0c, $00
	db	$0c, $00
	db	$08, $00

jump06	db	$11
	db	$10, $00
	db	$08, $00
	db	$18, $00
	db	$10, $00
	db	$10, $00
	db	$12, $00
	db	$07, $00
	db	$2f, $00
	db	$2f, $00
	db	$27, $00
	db	$33, $00
	db	$03, $00
	db	$0a, $00
	db	$04, $00
	db	$00, $00
	db	$28, $00
	db	$38, $00

jump06w db	$0b
	db	$20, $00
	db	$20, $00
	db	$10, $00
	db	$10, $00
	db	$18, $00
	db	$0c, $00
	db	$0c, $00
	db	$14, $00
	db	$18, $00
	db	$38, $00
	db	$10, $00

jump07	db	$0f
	db	$01, $00
	db	$01, $00
	db	$03, $00
	db	$06, $00
	db	$04, $00
	db	$14, $00
	db	$10, $00
	db	$14, $00
	db	$16, $00
	db	$07, $00
	db	$07, $00
	db	$07, $01
	db	$07, $01
	db	$0e, $01
	db	$6c, $00

jump07w db	$0b
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$68, $00
	db	$78, $00
	db	$70, $00

jump08	db	$0c
	db	$01, $00
	db	$0f, $00
	db	$0f, $00
	db	$0c, $00
	db	$08, $08
	db	$08, $08
	db	$08, $08
	db	$08, $0c
	db	$38, $02
	db	$78, $01
	db	$78, $00
	db	$30, $00

jump08w db	$09
	db	$10, $00
	db	$10, $00
	db	$10, $00
	db	$10, $00
	db	$20, $00
	db	$20, $06
	db	$60, $06
	db	$60, $03
	db	$40, $01

jump09	db	$0b
	db	$00, $60
	db	$30, $40
	db	$38, $40
	db	$38, $40
	db	$6d, $30
	db	$67, $14
	db	$42, $15
	db	$42, $0f
	db	$40, $0f
	db	$00, $07
	db	$00, $03

jump09w db	$0a
	db	$40, $00
	db	$00, $01
	db	$00, $01
	db	$00, $03
	db	$00, $32
	db	$00, $36
	db	$00, $34
	db	$00, $0c
	db	$00, $08
	db	$00, $08

jump10	db	$15
	db	$00, $06
	db	$00, $08
	db	$00, $08
	db	$00, $08
	db	$00, $00
	db	$00, $00
	db	$00, $08
	db	$00, $08
	db	$00, $0a
	db	$00, $0e
	db	$00, $0e
	db	$00, $06
	db	$70, $07
	db	$78, $03
	db	$78, $01
	db	$08, $00
	db	$0c, $00
	db	$04, $00
	db	$06, $00
	db	$02, $00
	db	$03, $00

jump10w db	$09
	db	$20, $00
	db	$20, $06
	db	$40, $06
	db	$40, $05
	db	$00, $05
	db	$00, $07
	db	$00, $06
	db	$00, $06
	db	$00, $04

jump11	db	$1c
	db	$60, $00
	db	$00, $01
	db	$00, $01
	db	$00, $01
	db	$00, $00
	db	$40, $00
	db	$40, $00
	db	$40, $00
	db	$40, $00
	db	$60, $00
	db	$60, $00
	db	$20, $00
	db	$30, $00
	db	$30, $00
	db	$30, $00
	db	$18, $00
	db	$18, $00
	db	$1c, $00
	db	$1c, $00
	db	$0c, $00
	db	$0e, $00
	db	$0e, $00
	db	$0a, $00
	db	$0a, $00
	db	$0a, $00
	db	$12, $00
	db	$12, $00
	db	$1b, $00

jump11w db	$09
	db	$02, $00
	db	$64, $00
	db	$6c, $00
	db	$68, $00
	db	$58, $00
	db	$10, $00
	db	$30, $00
	db	$20, $00
	db	$20, $00

jump12	db	$1c
	db	$0c, $00
	db	$10, $00
	db	$10, $00
	db	$10, $00
	db	$00, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$00, $00
	db	$10, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$18, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0e, $00
	db	$1e, $00
	db	$1c, $00
	db	$18, $00
	db	$18, $00
	db	$28, $00
	db	$28, $00
	db	$3c, $00

jump12w db	$0b
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$08, $00
	db	$10, $00
	db	$10, $00
	db	$10, $00
	db	$18, $00
	db	$0c, $00
	db	$06, $00
	db	$01, $00

squat01 db	$1a
	db	$06, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$00, $00
	db	$08, $00
	db	$00, $00
	db	$00, $00
	db	$04, $00
	db	$14, $00
	db	$14, $00
	db	$14, $00
	db	$10, $00
	db	$18, $00
	db	$1c, $00
	db	$1e, $00
	db	$1e, $00
	db	$1f, $00
	db	$0f, $00
	db	$0b, $00
	db	$1a, $00
	db	$16, $00
	db	$24, $00
	db	$2c, $00
	db	$2c, $00
	db	$36, $00

squat01w
	db	$0f
	db	$06, $00
	db	$06, $00
	db	$06, $00
	db	$04, $00
	db	$04, $00
	db	$0c, $00
	db	$0c, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$0c, $00
	db	$06, $00
	db	$03, $00
	db	$01, $00

squat02 db	$17
	db	$06, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$00, $00
	db	$0c, $00
	db	$04, $00
	db	$14, $00
	db	$14, $00
	db	$10, $00
	db	$10, $00
	db	$18, $00
	db	$18, $00
	db	$39, $00
	db	$3d, $00
	db	$3c, $00
	db	$1e, $00
	db	$1e, $00
	db	$1e, $00
	db	$14, $00
	db	$14, $00
	db	$24, $00
	db	$16, $00

squat02w
	db	$11
	db	$06, $00
	db	$06, $00
	db	$06, $00
	db	$04, $00
	db	$00, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$0c, $00
	db	$0c, $00
	db	$04, $00
	db	$04, $00
	db	$06, $00
	db	$02, $00
	db	$03, $00
	db	$01, $00
	db	$01, $00

squat03 db	$15
	db	$06, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$00, $00
	db	$04, $00
	db	$04, $00
	db	$14, $00
	db	$14, $00
	db	$14, $00
	db	$10, $00
	db	$30, $00
	db	$33, $00
	db	$3b, $00
	db	$39, $00
	db	$3c, $00
	db	$3c, $00
	db	$1c, $00
	db	$38, $00
	db	$48, $00
	db	$2c, $00

squat03w
	db	$12
	db	$06, $00
	db	$06, $00
	db	$06, $00
	db	$04, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$08, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$04, $00
	db	$06, $00
	db	$02, $00
	db	$02, $00
	db	$01, $00
	db	$01, $00

search	db	$1d
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$00, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$0c, $00
	db	$1e, $00
	db	$1e, $00
	db	$12, $00
	db	$12, $00
	db	$12, $00
	db	$12, $00
	db	$12, $00
	db	$12, $00
	db	$33, $00

searchw db	$0b
	db	$0c, $00
	db	$00, $00
	db	$12, $00
	db	$12, $00
	db	$12, $00
	db	$12, $00
	db	$33, $00
	db	$21, $00
	db	$21, $00
	db	$21, $00
	db	$21, $00

;dissolve buffer.  Sprite images are copied here then fiddled with.
disbuf	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
disbuf1	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

	end
