$chip(6502)
$title(Impossible Mission 2)
$paginate
$indent=8
**********************************************
*					     *
*	      Main code 		     *
*					     *
**********************************************

	%include macro.inc
	%include secseg.inc

	EXTERN	wr_main, wr_aux, rd_main, rd_aux
	EXTERN	spr_1
	EXTERN	sp_poin
	EXTERN	disbuf, disbuf1  ;animation constants
	EXTERN	scanlo, scanhi	;used to find collisions

	seg	temps
	double	pt1
	double	pt2

	SEG	graph

;**************************************************************************
;*	Dissolve character
;**************************************************************************
;	set up data to do dissolve
;--------------------------------------------------------------------------
	public	disolv,dodis
disolv	PROC
	sta	rd_aux
	sta	wr_aux
	lda	spr_1+2
	and	#$f0
	sta	spr_1+2
	lda	spr_1+8
	and	#$f0
	sta	spr_1+8

	lda	sp_poin 	;get pointers for current sprites,
	sta	pt1
	lda	sp_poin+1
	sta	pt1+1
	lda	#(LOW disbuf)	;replace with dissolve buffer address
	sta	sp_poin
	sta	pt2
	lda	#(HIGH disbuf)
	sta	pt2+1
	sta	sp_poin+1
	ldy	#0		;copy length of sprite
	lda	(pt1),y
	sta	(pt2),y
	tax
	iny
dslp1	lda	(pt1),y       ;copy actual (dark sprite) into dissolve buf
	sta	(pt2),y
	iny
	lda	(pt1),y
	sta	(pt2),y
	iny
	dex
	bne	dslp1
;
	lda	spr_1+11	;repeat above for light sprite
	sta	pt1+1
	lda	spr_1+10
	sta	pt1

	lda	#(LOW disbuf1)
	sta	spr_1+10
	sta	pt2
	lda	#(HIGH disbuf1)
	sta	pt2+1
	sta	spr_1+11
	ldy	#0
	lda	(pt1),y
	sta	(pt2),y
	tax
	iny
dslp2	lda	(pt1),y
	sta	(pt2),y
	iny
	lda	(pt1),y
	sta	(pt2),y
	iny
	dex
	bne	dslp2
	sta	rd_main
	sta	wr_main
	rts
;--------------------------------------------------------------------------
;	animate dissolve by clearing scan lines of image
;--------------------------------------------------------------------------
dodis
	sta	rd_aux
	sta	wr_aux
	lda	#(LOW disbuf)
	sta	pt1
	lda	#(HIGH disbuf)
	sta	pt1+1
	ldy	#7		;start as to avoid clearing length data
dslp3	lda	(pt1),y       ;get image
	bne	dsnxt1		;continue if still set
	tya			;skip by 7...
	clc
	adc	#7
	tay
	cmp	#64		;...wrapping around...
	beq	xxit			;no more uncleared entries, exit
	bcc	dslp3
	sec
	sbc	#64
	tay
	jmp	dslp3		;until uncleared entry found

dsnxt1	lda	#0		;clear scan line
	sta	(pt1),y

	lda	#(LOW disbuf1)	;REPEAT FOR LIGHT SPRITE
	sta	pt1
	lda	#(HIGH disbuf1)
	sta	pt1+1
	ldy	#7
dslp4	lda	(pt1),y
	bne	dsnxt2
	tya
	clc
	adc	#7
	tay
	cmp	#64
	beq	xxit
	bcc	dslp4
	sec
	sbc	#64
	tay
	jmp	dslp4

dsnxt2	lda	#0		;clear light sprite line
	sta	(pt1),y
xxit				;jump here when image is completely cleared
				;(remember, either part of sprite jumps here)
	sta	rd_main
	sta	wr_main
	rts
disolv	ENDPROC

	END

