$chip(6502)
$paginate


	 public   block_io,call_rwts
	 public   iocb_track,iocb_sector,iocb_io_buff_pntr,iocb_command
	 public   iocb_return_code
	 public   track,sector,read,seek,write,block_command,buf_len
	 public   buf_start

	 extern   rwts_header

	 %include secseg.inc


	 seg	  temps

buf_start	  dw	   $0000
buf_len 	  dw	   $0000

track		  ds	   1		     ;(current)
sector		  ds	   1		     ;(current)

current_buffer	  dw	   $0000
pages_left	  db	   $00

block_command	  ds	   1


************************************************

	 seg	  dkref

seek	 equ	  $00
read	 equ	  $01
write	 equ	  $02





block_io	  proc

	 lda	  buf_start
	 sta	  current_buffer
	 lda	  buf_start+1
	 sta	  current_buffer+1

	 lda	  buf_len+1
	 sta	  pages_left

..sector_loop
	 lda	  current_buffer
	 sta	  iocb_io_buff_pntr
	 lda	  current_buffer+1
	 sta	  iocb_io_buff_pntr+1

	 lda	  track
	 sta	  iocb_track
	 lda	  sector
	 sta	  iocb_sector

	 lda	  block_command
	 sta	  iocb_command

	 jsr	  call_rwts
	 bcs	  ..buzz		     ;error, so beep set code & RTS

	 dec	  pages_left
	 bne	  ..more_to_do

	 rts


..more_to_do
	 inc	  current_buffer+1

	 ldx	  sector
	 inx
	 cpx	  #$10
	 bcc	  ..store_new_sector

	 ldx	  track
	 inx
	 cpx	  #$23
	 bcc	  ..store_new_track
	 jmp	  ..buzz
..store_new_track
	 stx	  track
	 ldx	  #$00

..store_new_sector
	 stx	  sector

	 jmp	  ..sector_loop

*********************************************************


call_rwts
	 lda	  #$60			     ;slot #6*$10
	 sta	  iocb_slot
	 sta	  iocb_last_slot

	 lda	  #$01
	 sta	  iocb_drive_num
	 sta	  iocb_last_drive

	 lda	  #$00
	 sta	  iocb_vol_num
	 sta	  iocb_last_vol_num

	 lda	  #3			     ;allow 3 consecutive
	 sta	  ..error_count 	     ;errors

..set_for_rwts_call
	 lda	  $c083
	 lda	  $c083
	 lda	  #high(iocb)
	 ldy	  #low(iocb)
	 jsr	  rwts_header
	 lda	  $c08b
	 lda	  $c08b
	 bcc	  ..good_rwts

	 dec	  ..error_count
	 bpl	  ..set_for_rwts_call

..buzz
	 ldy	  #$40
..buzzlp1
	 sta	  $c030 		     ;beep and then return
	 ldx	  #$40
..buzzlp
	 dex
	 bne	  ..buzzlp
	 dey
	 bne	  ..buzzlp1
	 sec				     ;set code for error

..good_rwts
	 rts

***************************************************************

..error_count	  ds	   1









***************************************************************

iocb
		  db	   $01		     ;table type
iocb_slot	  db	   $60
iocb_drive_num	  db	   $01
iocb_vol_num	  db	   $00
iocb_track	  db	   $00
iocb_sector	  db	   $00
iocb_dct_pntr	  dw	   iocb_dct
iocb_io_buff_pntr dw	   $ffff
		  db	   $00		     ;not used
iocb_byte_count   db	   $00		     ;00 for 256 bytes

iocb_command	  db	   $00		     ;$00 - seek
					     ;$01 - read
					     ;$02 - write
					     ;$04 - format

iocb_return_code  db	   $00		     ;$00 - no errors
					     ;$08 - error during init
					     ;$10 - write protected
					     ;$20 - volume mismatch
					     ;$40 - drive error
					     ;$80 - read error

iocb_last_vol_num db	   $00		     ;MUST init
iocb_last_slot	  db	   $00
iocb_last_drive   db	   $00


iocb_dct	  db	   $00,01,$d8,$ef

block_io endproc

	 end
