$chip(6502)
$title(Impossible Mission 2)
$paginate
$indent=8
**********************************************
*					     *
**********************************************

	%include macro.inc
	%include prmseg.inc

	EXTERN	wr_main, wr_aux, rd_main, rd_aux
	extern	stick,chomp
	EXTERN	page1, page2
	extern	spr_1
	extern	stunflg,sfloors,n_sfloors,drkflg,bulbflg
	EXTERN	workon, stkval(page0)
	EXTERN	scroldn, scrolup
	EXTERN	lifts,collide(page0),objects,build
	extern	copy_b,copy_e,clear,prmsec

	extern	numslo,numshi,nxpcc,xsppoint,xdraw

	extern	display(page0), side(page0), dopan
	extern	dorkimg(page0), dorknim(page0), dorksta(page0)
	extern	onlift(page0), liftnum(page0), collide(page0)
	extern	dorkx(page0),dorky(page0),entryx(page0),entryy(page0)
	extern	stone(page0)
	extern	stamp,erbuff
	extern	pins
	extern	erasobj,donesch
	extern	scanlo,scanhi,sshape
	extern	bmbimg,numatab,numbtab

	extern	holes,dobmb1,reslfts,level

	extern	tapcnt,musics,tower16,played

	extern	goodterm,twrmusic
	extern	deadflg
	extern	elvin_screens,score_screen
	extern	termnums
	extern	shfsfl
	extern	boom

	public	insrch

	SEG	PAGE0

	single	insrch		;if displaying SEARCH or other

	single	joytmp		;temp - mainly for collision info
	single	objnum		;current object number
	single	savex		;coordinate of saved screen area
	single	savey
	single	shapet
	single	row
	single	column
	single	shape
	single	bombtime
	single	tbombx
	single	tbomby
	single	havebomb
	
	single	tower_door_flag

	public	bombtime,havebomb,tower_door_flag

	SEG	temps
	single	trow
	single	tcolumn
	single	spxofs
	single	spyofs
	single	height
	single	width
	double	spoint
	double	bitmap
	single	countp
	single	joytmp1


	SEG	maincode

;**************************************************************************
;*	JOYSTICK CONTROL PROCESSING
;**************************************************************************
	public	joyproc
joyproc PROC
	jsr	dotbomb

	lda	dorksta
	beq	dojoy		;only process joystick if not falling
	lda	insrch		;see if insearch was set before
	lbeq	endmov
	jsr	unmsg		;clear searching message
	jmp	endmov
dojoy

;--------------------------------------------------------------------------
;check for jump
	lda	stkval
	and	#$C0		;test for either fire button
	lbeq	njmp
;set bomb if squatting
	lda	dorkimg
	cmp	#0
	bne	butnorm
	lda	level
	cmp	#1
	beq	..below
	lda	side		;only check for panel if standing
	beq	butnorm
..below
	sta	rd_main
	sta	wr_main
	lda	played
	cmp	#63
	bne	..play_finished
	lda	#0
	sta	played
..play_finished
	jsr	dopan
	sta	rd_aux
	sta	wr_aux
	jmp	endmov
butnorm
	lda	#29
	cmp	dorkimg
	beq	xdobmb
	lda	#14		;see if in jump
	cmp	dorkimg
	bcs	stjmp
	lda	#26
	cmp	dorkimg
	bcs	njmp1
stjmp	lda	#15		;start jump
	sta	dorknim
njmp1	jmp	endmov

xdobmb
	lda	havebomb
	lbeq	endmov
	cmp	#2
	bne	..nosttim
	lda	dorkx
	sta	tbombx
	lda	dorky
	sta	tbomby
	lda	#3
	sta	bombtime


	sta	rd_aux
	sta	wr_aux

	ldy	#0
..hllp2	lda	holes,y
	cmp	#0
	beq	..fndhl1
..hllp1	iny
	iny
	iny
	cpy	#24
	bne	..hllp2
	jmp	..nosttim
..fndhl1
	lda	tbomby
	sec
	sbc	#4		;offset for actual floor
	and	#$f8
	lsr	a
	lsr	a
	lsr	a
	sta	holes+2,y

	lda	tbombx
	lsr	a
	sta	holes+1,y

	lda	#2
	sta	holes,y

	sta	rd_main
	sta	wr_main


..nosttim
	lda	spr_1+2
	and	#$80
	ora	havebomb
	ldx	dorkx
	ldy	dorky
	sta	rd_main
	sta	wr_main
	long	prmsec,dobmb1
	lda	#0
	sta	havebomb
	jmp	endmov
njmp

;avoid switching directions when jumping
	lda	#14		;see if in jump
	cmp	dorkimg
	bcs	..not_in_jump
	lda	#26
	cmp	dorkimg
	lbcs	endmov
..not_in_jump
	lda	stkval
	cmp	#$01
	beq	..notclrsrch
	lda	insrch		;see if insearch was set before
	beq	..notclrsrch
	jsr	unmsg		;clear searching message
..notclrsrch
;--------------------------------------------------------------------------
;check for left
	lda	stkval
	and	#$04
	beq	nleft
;also check for up and down on hlift
	lda	onlift		;ignore if not on any lift
	beq	nollf
	lda	stkval		;ignore if U or D not also pressed
	and	#$03
	beq	nollf
	lda	liftnum 	;get number and index (18 bytes/lift)
	asl	a
	sta	joytmp
	asl	a
	asl	a
	asl	a
	adc	joytmp
	tax
	sta	rd_main
	sta	wr_main
	lda	lifts+2,x	;ignore vertical lifts here
	bne	llfimv
	lda	lifts+14,x	;don't start move if in motion
	bne	llfimv
	lda	lifts+3,x	;don't move left if at left end
	beq	llfimv
	dec	lifts+3,x
	lda	#$ff
	sta	lifts+14,x
llfimv
	sta	rd_aux
	sta	wr_aux
	lda	stkval		;also squat if joystick down
	and	#$02
	beq	nupxx
	jmp	nup
nupxx	jmp	endmov
nollf

	lda	spr_1+2 	;check direction
	and	#$80
	beq	setrun
	lda	spr_1+2 	;force direction
	and	#$7f
	sta	spr_1+2
	lda	#0		;set standing if direction change
	sta	dorknim
	jmp	endmov

;-------------------------------------------------
;set run is used by left and right routines
setrun	lda	dorkimg 	;if not standing, bypass
	bne	nostrn
	lda	#1		;otherwise set next animation to start run
	sta	dorknim
nostrn	jmp	endmov
;

nleft

;-------------------------------------------------------------------------
;check right
	lda	stkval		;SEE LEFT FOR ADDITIONAL INFO
	and	#$08		;(right is simply a modification of left)
	beq	nrit
;also check for up and down on hlift
	lda	onlift
	beq	norlf
	lda	stkval
	and	#$03
	beq	norlf
	lda	liftnum 	;get number and index (18 bytes/lift)
	asl	a
	sta	joytmp
	asl	a
	asl	a
	asl	a
	adc	joytmp
	tax
	sta	rd_main
	sta	wr_main
	lda	lifts+2,x	;ignore vertical lifts here
	bne	lrtimv
	lda	lifts+14,x	;don't start move if in motion
	bne	lrtimv
	lda	lifts+3,x	;don't move right if at right end
	clc
	adc	lifts+4,x
	cmp	lifts+7,x
	beq	lrtimv
	inc	lifts+3,x
	lda	#$1
	sta	lifts+14,x
lrtimv
	sta	rd_aux
	sta	wr_aux
	lda	stkval		;also squat if joystick down
	and	#$02
	lbne	nup
	jmp	endmov
norlf
	lda	spr_1+2 	;check direction
	and	#$80
	bne	setrun
	lda	spr_1+2 	;force direction
	ora	#$80
	sta	spr_1+2
	lda	#0
	sta	dorknim
	jmp	endmov
nrit

;--------------------------------------------------------------------------
;check for up
	lda	stkval
	and	#$01
	lbeq	nup
;check collide for onlift
	lda	onlift		;ignore if not on lift
	sta	joytmp
	lbeq	noulf

	lda	side		;check for corridor elevator
	beq	ucklf

	cmp	#1
	beq	ucklf1
	cmp	#3
	beq	ucklf1
	lda	dorkimg
	bne	noulf
	sta	rd_main
	sta	wr_main

	jsr	scrolup
	sta	rd_aux
	sta	wr_aux
	jmp	endmov

ucklf1
;between towers
	lda	#$ff
	sta	tower_door_flag

	move	entryx,dorkx
	move	entryy,dorky
	
	jmp	endmov

ucklf

	lda	liftnum 	;get number and index (18 bytes/lift)
	asl	a
	sta	joytmp
	asl	a
	asl	a
	asl	a
	adc	joytmp
	tax
	sta	rd_main
	sta	wr_main
	lda	lifts+14,x	;don't start move if in motion
	sta	joytmp
	bne	lupimv
	lda	lifts+2,x	;ignore horizonal lifts here
	beq	lupimv
	lda	lifts+3,x	;don't move up if at top
	beq	lupimv
	dec	lifts+3,x
	lda	#$ff
	sta	lifts+14,x
lupimv
	sta	rd_aux
	sta	wr_aux

noulf
	lda	joytmp		;don't search if lift moving
	bne	nsmv
	lda	collide 	;don't search if in floor
	and	#$40
	bne	nsmv
	lda	dorkimg 	;check image to see if already searcing
	cmp	#30
	lbeq	srchnow 	;continue search
	lda	#$20
	and	collide
	lbne	isrch
nsmv	jmp	nup

nup
	lda	insrch		;see if insearch was set before
	beq	ckdn
	jsr	unmsg		;clear searching message
ckdn
;--------------------------------------------------------------------------
;check for down
	lda	stkval		;SEE UP FOR ADDITIONAL INFO (lifts mainly)
	and	#$02		;squatting differs from searching and is
	lbeq	ndn		;detailed below
;check for onlift
	lda	onlift
	lbeq	nodlf

	lda	side
	beq	dclkf
	cmp	#1
	beq	dclkf
	cmp	#3
	beq	dclkf
	lda	dorkimg
	bne	nodlf
	sta	rd_main
	sta	wr_main

	jsr	scroldn
	sta	rd_aux
	sta	wr_aux
	jmp	endmov
dclkf

	lda	liftnum
	asl	a
	sta	joytmp
	asl	a
	asl	a
	asl	a
	adc	joytmp
	tax
	sta	rd_main
	sta	wr_main
	lda	lifts+2,x	;ignore this for horizontal lifts
	beq	ldnimv
	lda	lifts+14,x	;don't start if already moving
	bne	ldnimv
	lda	lifts+3,x	;don't move down if at bottom
	clc
	adc	lifts+4,x
	cmp	lifts+7,x
	beq	ldnimv
	inc	lifts+3,x
	lda	#$1
	sta	lifts+14,x
ldnimv
	sta	rd_aux
	sta	wr_aux
nodlf
	lda	dorkimg 	;see if in squat
	cmp	#27
	bcc	stsqu
	cmp	#29
	beq	squbyp		;ignore if at end of squat
	bcc	contsqu
	jmp	stsqu
contsqu lda	dorkimg 	;continue to next frame of squat
	sta	dorknim
	inc	dorknim
	jmp	endmov
stsqu	lda	#27
	sta	dorknim
squbyp
	jmp	endmov
ndn

;--------------------------------------------------------------------------
;default (no joystick input) processing
	lda	dorkimg
	beq	endmov		;do nothing if just standing
	lda	#14		;check if jump or squat else running
	cmp	dorkimg
	bcc	tstsqu
rstimg	lda	#0		;running, reset to standing
	sta	dorknim
	jmp	endmov
tstsqu	lda	dorkimg 	;see if squatting or searching
	cmp	#27
	bcc	endmov		;jumping - no special action
;stand or squat
	lda	dorkimg
	cmp	#30
	beq	rstimg		;if searching, reset to standing
	lda	dorkimg
	cmp	#27		;if first squat, reset to standing
	beq	rstimg
	sta	dorknim 	;go to previous squat phase otherwise
	dec	dorknim
	jmp	endmov
endmov	rts

;--------------------------------------------------------------------------
;	search object
;--------------------------------------------------------------------------
;* initate search
isrch
	ldx	dorkx
	ldy	dorky
	jsr	erasobj 	;look up searching object
	sta	objnum		;multiply by 5 (sizeof(objects))
	lbmi	zapobj2		;negative means nothing found - error
	
	asl	a
	asl	a
	adc	objnum
	tax
	sta	rd_main
	sta	wr_main
	lda	objects+2,x	;hold found image
	lbeq	dosafe		;don't search unblown safe
	cmp	#2
	lbeq	doterm		;special handling for terminals
	
	cmp	#3		;this value also checks for dead in lastroom
	lbne	..normobj
	lda	tower16
	cmp	#$80
	lbne	doterm
	
	lda	objnum
	cmp	goodterm
	beq	dowin	
	
	lda	#$2
	ora	deadflg
	sta	deadflg
	rts
	
;delay to replace vblank
idly	db	0
delay	lda	#0
..xdly	sta	idly
	dec	idly
	lda	idly
	lda	idly
	lda	idly
	bne	..xdly
	rts
	
	public	dowin
dowin
	jsr	copy_b			;stabilize the screens
	long	prmsec,elvin_screens
	sta	rd_aux
	sta	wr_aux

	lda	#29
	sta	spyofs

	ldy	spyofs
	lda	scanlo,y
	sta	spoint
	lda	scanhi,y
	ora	#$40
	sta	spoint+1

	ldy	#20
	lda	(spoint),y
	sta	joytmp
	lda	#$1c
	sta	(spoint),y

	ldx	#0
..vlpq1
	jsr	delay
	dex
	bne	..vlpq1
	
	lda	joytmp
	sta	(spoint),y

dotanilp
	ldy	spyofs
	lda	scanlo,y
	sta	spoint
	lda	scanhi,y
	ora	#$40
	sta	spoint+1

	ldy	#20
	lda	(spoint),y
	sta	joytmp
	lda	#$1c
	sta	(spoint),y

	jsr	delay
	jsr	delay

	lda	joytmp
	sta	(spoint),y

	inc	spyofs
	lda	spyofs
	cmp	#142
	bne	dotanilp

	lda	#$1c
	sta	(spoint),y


	ldx	#0
..vlpx1
	jsr	delay
	dex
	bne	..vlpx1

	sta	rd_main
	sta	wr_main
	long	prmsec,score_screen

..normobj
;normal object search
	sta	rd_main
	sta	wr_main

	jsr	setrwcl 	;put up searching box
	lda	#29
	jsr	putbox
	jsr	seterb

	lda	#30		;set searching image
	sta	dorknim
	lda	#1		;set searching flag (so we know to erase
	sta	insrch		;	search box)

	jmp	zapobj1

;-------------------
;display terminal screen and get input
	public	doterm
doterm
	ldx	#38
	jsr	chomp

	lda	#6
	sta	joytmp
redonum
	sta	rd_main
	sta	wr_main
	lda	joytmp
	long	prmsec,termnums

cdtrm	jsr	stick
	and	#8
	beq	cdtrm3
	dec	joytmp
	bmi	rstr
	jmp	redonum
cdtrm3	lda	stkval
	and	#4
	beq	cdtrm4
	inc	joytmp
	lda	joytmp
	cmp	#7
	bne	rstr1
	lda	#0
	sta	joytmp
rstr1	jmp	redonum
rstr	lda	#6
	sta	joytmp
	jmp	redonum
cdtrm4
	lda	stkval
	and	#$C0
	beq	cdtrm

cdtrm1	jsr	stick		;wait for joystick release
	and	#$C0
	bne	cdtrm1

	ldx	joytmp
	cpx	#6		;no operation?
	lbeq	nosfnd
;
dofunc
	public	dofunc
;*debug
	lda	pins+30,x
	beq	nosfnd
	sec
	sbc	#1
	sta	pins+30,x
;do what the selected object is supposed to

	cpx	#3
	bne	nrslfts
	long	prmsec,reslfts
	jmp	nosfnd
nrslfts
	cpx	#5
	bne	nostn
	lda	#14		;(30)number of seconds to stun
	sta	stunflg
	jmp	nosfnd
nostn
	cpx	#4
	bne	nosflr
	long	prmsec,shfsfl
	jmp	nosfnd

nosflr
	cpx	#0	;time bomb
	bne	notmbmb
	lda	#2
	sta	havebomb
	jmp	nosfnd
notmbmb
	cpx	#1	;grenade
	bne	nomine
	lda	#1
	sta	havebomb
	jmp	nosfnd
nomine
	cpx	#2	;lightbulb
	bne	nosfnd
	lda	#1
	sta	bulbflg
	lda	#0
	sta	drkflg
	jmp	nosfnd
;tbd
nosfnd
	long	prmsec,clear
	jsr	build
	long	prmsec,copy_e
	sta	rd_aux
	sta	wr_aux

;*** fall through and do nothing for now

;------------------
;ignore unblown safe
dosafe	lda	#0		;reset animation
	sta	dorknim
	jmp	zapobj1
;---------------------------------------------------------------------------
;*lookup object by number and decrement time
srchnow
	sta	dorknim
	lda	insrch		;insrch >1 means display found
	cmp	#1
	lbne	zapobj1
				;lookup object by number
	lda	objnum
	asl	a
	asl	a
	adc	objnum
	tax
	sta	rd_main
	sta	wr_main
	lda	objects+3,x	;hold found image
	lbeq	zapobj1
	dec	objects+3,x	;decrement time
	lbne	nzapobj
;redraw room to erase object (build will not draw object with zero search time)
;***
	lda	objnum
	asl	a
	asl	a
	adc	objnum
	tax
	lda	objects+2,x	;hold found image
	cmp	#1
	bne	..ntsf

	lda	tower16		;save random music
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	tay
	lda	twrmusic,y
	sta	joytmp
	
	lda	tapcnt
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	tay
	lda	joytmp
	sta	musics,y
	iny
	cpy	#6
	beq	..eotp
	tya
	asl	a
	asl	a
	asl	a
	asl	a
	asl	a
	sta	tapcnt
..eotp
	lda	#38
	jmp	goodnum

..ntsf

;not a safe, change objnum to what is hidden
	lda	objects+4,x

goodnum
	sta	objnum
	dec	objnum
;***
	inc	insrch
				;give what found to him
	ldx	objnum
	bmi	nofnd
	inc	pins,x
	lda	objnum
	sec
	sbc	#30
	bcc	nnfnd
	clc
	adc	#31
	sta	shapet
	jmp	nnofnd
nnfnd	lda	#95
	sta	shapet
;also put up colored number sprite
	jmp	nnofnd
nofnd
	lda	#30
	sta	shapet
nnofnd
	jsr	stampbuf	;restore screen under search box
	long	prmsec,clear
	lda	#0
	jsr	build
	jsr	setrwcl 	;put up icon of what found
	lda	shapet
	jsr	putbox
	lda	objnum
	cmp	#30
	bcs	nonum
	sta	rd_aux
	sta	wr_aux
	ldx	#1
	stx	nxpcc+2
	cmp	#20
	bcc	contn
	sbc	#20
	jmp	donum
contn
	ldx	#7
	stx	nxpcc+2
	cmp	#10
	bcc	contnn
	sbc	#10
	jmp	donum
contnn	ldx	#4
	stx	nxpcc+2
donum	tax
	lda	#6
	sta	nxpcc
	lda	#4
	sta	nxpcc+1
	lda	#$e6
	sta	nxpcc+3
	lda	numslo,x
	sta	nxpcc+4
	lda	numshi,x
	sta	nxpcc+5
	lda	#low nxpcc
	sta	xsppoint
	lda	#high nxpcc
	sta	xsppoint+1
	clc
	lda	row
	asl	a
	asl	a
	asl	a
	tay
	lda	column
	adc	column
	tax
	sta	rd_main
	sta	wr_main
	long	prmsec,xdraw
	sta	rd_main
	sta	wr_main
nonum
	jsr	copy_b
	jsr	seterb
				;add what found to inventory
	jmp	zapobj1
;--------------------
;display searching thermometer bar
nzapobj
	lda	objects+3,x
	lsr	a
	cmp	#14		;max length is 15
	bcc	noovf
	lda	#14
noovf
	sta	joytmp
	cmp	#7
	bcc	jstone
	sec
	sbc	#7
jstone
				;index partial bar images
	clc
	adc	#105		;point to proper partial bar
	sta	shape

	sta	rd_main
	sta	wr_main
	jsr	setrwcl
	inc	column		;move to bar position
	inc	column
	inc	row
	inc	row

	lda	joytmp
	cmp	#7
	bcc	nofrst
	inc	column		;stamp right side (since len>7)
	inc	column
	lda	shape
	ldx	column
	ldy	row
	jsr	stamp
	dec	column
	dec	column
	lda	#105+7		;set to stamp full left side
	sta	shape
nofrst
	lda	shape
	ldx	column
	ldy	row
	jsr	stamp		;stamp left part of bar
;adjust row and column for seterb
;	inc	column
;	inc	column
	dec	row
	dec	row
;	inc	column
;	inc	column
	jsr	seterb
	jmp	zapobj2

zapobj1
;	jsr	restamp
zapobj2
	sta	rd_aux
	sta	wr_aux
	jmp	endmov

;-------------------------------------------------------------------------
;remove searching box or found icon
unmsg
	sta	rd_main
	sta	wr_main
	jsr	stampbuf
	jsr	seterb
	sta	rd_aux
	sta	wr_aux
	lda	#0
	sta	insrch
	lda	#1
	sta	donesch
	rts
	
;---------------------------
;restore area under search box
stampbuf
	lda	#$60		;set erase screen as target
	sta	stone
	ldx	savex
	ldy	savey
	lda	#94
	jsr	stamp
	lda	savex
	sta	column
	lda	savey
	sta	row
	rts

;-----------------------------
;set row and column for searching box
setrwcl
	lda	#$60		;set erase screen as target
	sta	stone

	move	height,#24
	lda	dorky		;convert character coordinate to row & col
	lsr	a
	lsr	a
	lsr	a
	sec
	sbc	#3
	sta	row
	lda	dorkx
	lsr	a
	clc
	adc	#5		;shift to the side
	and	#$fe
	cmp	#32
	bcc	nopush
	sbc	#16		;if off screen to the right, shift to left
nopush
	sta	column
	rts

;------------------------------------
;set erase screen restore area to put up searching box area
;note that sprite erasing is 3 wide
seterb
	sta	wr_aux
	lda	column
	tay
	dey
	dey
	tya
	sta	erbuff+$38
	sta	erbuff+$78
	iny
	iny
	iny	;
	iny	;
	iny
	iny
	tya
	sta	erbuff+$3c
	sta	erbuff+$7c
	lda	row
	asl	a
	asl	a
	asl	a
	sta	erbuff+$39
	sta	erbuff+$79
	sta	erbuff+$3d
	sta	erbuff+$7d
	lda	#24
	sta	erbuff+$3a
	sta	erbuff+$7a
	sta	erbuff+$3e
	sta	erbuff+$7e
	lda	#$e6
	sta	erbuff+$3b
	sta	erbuff+$7b
	sta	erbuff+$3f
	sta	erbuff+$7f
	rts

;---------------------------------------------------
;put up searching box
putbox
	sta	shapet
	ldy	row
	sty	savey
	ldx	column
	stx	savex
	move	width,#4
	lda	#94	;save area and stamp box
	jsr	stave
restamp
	ldx	savex
	ldy	savey
	lda	shapet
	jsr	stamp
	lda	savex
	sta	column
	rts

joyproc ENDPROC


**********************************************
*	Save screen memory to buffer	     *
*  Input parameters:			     *
*	Yrow:	character row (0-23)	     *
*	Xcolumn: graphics column (0-19)*2     *
*	Ashape:	shape number (0-??)	     *
*		Table can be found in	     *
*		rooms.asm (sshape)	     *
*	height: number of scan-lines	     *
*	width:	number of columns	     *
*  Expects Main bank for read & write.	     *
*  Returns in same condition.		     *
*  Input values not modified.		     *
*  Format for data in table is in rooms.asm  *
**********************************************
stave	PROC
	sta	rd_main
	stx	tcolumn
	sty	trow
	asl	a
	tax
	lda	sshape,x
	sta	spoint
	lda	sshape+1,x
	sta	spoint+1
	sta	rd_aux

	ldy	#0
	lda	width
	sta	(spoint),y

..mloop
	jsr	stavesub
	inc	tcolumn
	jsr	stavesub
	inc	tcolumn
	dec	width
	lbne	..mloop
	sta	wr_main
	sta	rd_main

	rts

stavesub
	dinc	spoint

	lda	trow
	asl	a
	asl	a
	asl	a
	tax
	move	countp,height

..lp1	lda	scanlo,x
	sta	bitmap
	lda	scanhi,x
	ora	#$60		;stone
	sta	bitmap+1

	ldy	tcolumn
	lda	(bitmap),y
	and	#$7f
	ldy	#0
	sta	(spoint),y

	inx
	dinc	spoint
	dec	countp
	bne	..lp1

	lda	#$80
	sta	(spoint),y
	dinc	spoint

	lda	trow
	asl	a
	asl	a
	asl	a
	tax
	move	countp,height

..lp2	lda	scanlo,x
	sta	bitmap
	lda	scanhi,x
	ora	#$60		;stone
	sta	bitmap+1

	ldy	tcolumn
	sta	rd_main
	lda	(bitmap),y
	sta	rd_aux
	and	#$7f
	ldy	#0
	sta	(spoint),y

	inx
	dinc	spoint
	dec	countp
	bne	..lp2

	lda	#$80
	sta	(spoint),y
	rts

stave	ENDPROC

;******* handle timebomb
dotbomb	proc
	public	dotbomb
;time bomb handling
	lda	bombtime
	lbne	..ntbmbt
	lda	#$ff
	sta	bombtime
	ldx	tbombx
	ldy	tbomby
	inx			;TWEAK
	dex
	sta	rd_main
	sta	wr_main
	jsr	erasobj 	;look up searching object
	sta	objnum
	bmi	..doboom	;no object found
	
	asl	a
	asl	a
	adc	objnum
	tax
	lda	objects+2,x
	bne	..clnup			;also should hole floor if not safe
	lda	#1
	sta	objects+2,x


	sta	rd_aux
	sta	wr_aux

	ldy	#0	;undo holes for safe
..hlllp2	lda	holes,y
	cmp	#0
	bne	..fndhll1
..hlllp1	iny
	iny
	iny
	cpy	#24
	bne	..hlllp2
	jmp	..doboom
..fndhll1
	lda	tbomby
	sec
	sbc	#4		;offset for actual floor
	and	#$f8
	lsr	a
	lsr	a
	lsr	a
	cmp	holes+2,y
	bne	..hlllp1

	lda	tbombx
	lsr	a
	cmp	holes+1,y
	bne	..hlllp1

	lda	#0
	sta	holes,y

	sta	rd_main
	sta	wr_main

	jmp	..doboom
..clnup
	lda	#0
	sta	objects+3,x
..doboom
	sta	rd_main
	sta	wr_main
	long	prmsec,boom
	long	prmsec,clear
	jsr	build
	long	prmsec,copy_e
	sta	rd_aux
	sta	wr_aux

..ntbmbt
	rts
dotbomb	endproc
	

	END
