$chip(6502)
$title(Impossible Mission II)

**********************************************
*					     *
*	Set-up for elevator move	     *
*					     *
**********************************************

	%include macro.inc
	%include prmseg.inc

	EXTERN	chomp, copy_b
	EXTERN	side(page0), stone(page0), tower16(page0)
	EXTERN	walkway, stamp
	EXTERN	scanlo, scanhi, rd_main, wr_main, rd_aux, wr_aux
	EXTERN	handsp, sp_xpos, sp_ypos, sp_colr, sp_flag, sp_poin
	EXTERN	display(page0), workon, page1, erasp, prmsec, draw
	EXTERN	stick
	EXTERN	xdraw, xsppoint, numslo, numshi, nxpcc
	EXTERN	pins, pinpos, corpin, erbuff, nmsl, nmsr, dotowr
	EXTERN	updtim, clock, timer, tcount, tapcnt, hex, decimal, musics
	extern	musiseg,tonetbl,durcom,rd_aux,rd_main

	PUBLIC	panel,dopan,prtime,played

	SEG	page0

	single	row
	single	column
	single	shape
	single	updown
	single	played
	single	played1
	single	playtmp
 
;	seg	temps

	double	mode
	single	butn
	single	scanl
	single	coll
	single	counts
	single	stow
	single	tmask
	single	motion
	single	tslow

	SEG	temps

 	double	from
	double	to
	double	to2
	double	to3
	double	shift

	double	punt
	single	lhght
	single	lwidt
	single	mtow
	single	orig
	single	scan
	single	tmpx
	single	tmpy
	double	tmpp

	single	spxofs
	single	spyofs

	SEG	maincode

*******************************

panel	PROC

	lda	#0
	sta	played1

	move	stone,#$60

	sta	rd_aux
	ldx	#21

..lpcsc lda	tbutrow-1,x
	jsr	..logbt
	lda	tbutrow-1,x
	clc
	adc	#1
	jsr	..logbt
	dex
	bne	..lpcsc
	sta	rd_main

	ldx	#14	; draw panel
	jsr	chomp

	sta	rd_aux	 ;hi walkways between
	ldx	#16*8+1  ;towers
	lda	scanlo,x
	sta	punt
	lda	scanhi,x
	ora	stone
	sta	punt+1
	sta	rd_main

	lda	#0
	sta	wr_aux
	ldy	#13
	sta	(punt),y
	ldy	#17
	sta	(punt),y
	ldy	#21
	sta	(punt),y
	ldy	#25
	sta	(punt),y

	sta	wr_main
	ldy	#12
	sta	(punt),y
	ldy	#16
	sta	(punt),y
	ldy	#20
	sta	(punt),y
	ldy	#24
	sta	(punt),y

	lda	tower16 ; tower rooms
	sec
	sbc	#16
	and	#$7f
	sta	mtow
	move	column,#14
..olpx
	move	row,#21
	lda	mtow
	and	#$7f
	sta	mtow
..loop
	ldx	mtow
	inc	mtow
	inc	mtow

	move	shape,#103
	lda	walkway+1,x
	and	#$f
	beq	..do1

	dec	shape
	lda	walkway,x
	and	#$20
	bne	..do1
	dec	shape
..do1
	lda	shape
	ldy	row
	ldx	column
	jsr	stamp

	dec	row
	lda	row
	cmp	#15
	bne	..loop
*tz
	inc	mtow
	inc	mtow
	inc	mtow
	inc	mtow
*tz
	lda	column
	clc
	adc	#4
	sta	column
	cmp	#26
	bne	..olpx

	lda	tower16
	sec
	sbc	#32
	and	#$7f
	sta	mtow

	ldy	#12

..lp	move	tmask,#$40
	sta	wr_aux
	jsr	..brg

	iny
	move	tmask,#$80
	lda	mtow
	clc
	adc	#16
	and	#$70
	sta	mtow

	sta	wr_main
	jsr	..brg

	lda	mtow
	and	#$70
	sta	mtow
	iny
	iny
	iny
	cpy	#26
	bcc	..lp

	jsr	smap
	rts

..logbt asl	a
	asl	a
	asl	a
	tay
	lda	scanlo,y
	sta	punt
	lda	scanhi,y
	ora	#$04
	sta	punt+1
	ldy	tbutcol-1,x
	txa
	sta	(punt),y
	iny
	sta	(punt),y
	iny
	sta	(punt),y
	rts

..brg	move	row,#21*8+5

..lpbrg ldx	mtow
	lda	walkway,x
	and	tmask
	beq	..nxbrg

	sta	rd_aux
	ldx	row
	lda	scanlo,x
	sta	punt
	lda	scanhi,x
	ora	stone
	sta	punt+1
	sta	rd_main

	lda	#0
	sta	(punt),y

..nxbrg inc	mtow
	lda	row
	sec
	sbc	#4
	sta	row
	cmp	#16*8
	bcs	..lpbrg

	rts

panel	ENDPROC

*******************************

smap	PROC

	lda	workon
	pha
	move	stone,#$60
	sta	workon
	lda	#0
	sta	spyofs
	sta	spxofs

	ldx	#32	; draw map
	jsr	chomp

	lda	tower16
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	sta	shape
	tax
	lda	tbutrow,x
	sta	row
	lda	tbutcol,x
	clc
	adc	#1
	and	#$fe
	sta	column
	move	lhght,#14
	move	lwidt,#2
	jsr	light

	sta	wr_aux

	dmovi	xsppoint,dotowr

	ldx	shape
	lda	tdotcol,x
	sta	dotowr
	lda	tdotrow,x
	sta	dotowr+1
	sta	rd_main
	sta	wr_main
	ldx	spxofs
	ldy	spyofs
	long	prmsec,xdraw

	move	row,#15
	move	column,#6
	lda	shape
	clc
	adc	#71
	sta	shape

	lda	shape
	ldy	row
	ldx	column
	jsr	stamp

	pla
	sta	workon
	rts

smap	ENDPROC
***********************************

dopan	PROC

	move	clock,#$ff
	move	motion,#20
	jsr	panel
	extern	dmap
	sta	rd_aux
	sta	wr_aux
	lda	#0
	jsr	dmap
	sta	rd_main
	sta	wr_main
	
	jsr	copy_b
	jsr	prtime

****

	lda	pinpos+0
	bpl	..ok1

	ldx	#0

..lpo1	lda	pins+00,x
	bne	..fnd1
	inx
	cpx	#10
	bcc	..lpo1
	jmp	..ok1

..fnd1	stx	pinpos+0

..ok1	lda	pinpos+1
	bpl	..ok2

	ldx	#0

..lpo2	lda	pins+10,x
	bne	..fnd2
	inx
	cpx	#10
	bcc	..lpo2
	jmp	..ok2

..fnd2	stx	pinpos+1

..ok2	lda	pinpos+2
	bpl	..ok3

	ldx	#0

..lpo3	lda	pins+20,x
	bne	..fnd3
	inx
	cpx	#10
	bcc	..lpo3
	jmp	..ok3

..fnd3	stx	pinpos+2

..ok3
****
	sta	wr_aux
	move	sp_xpos+6*2,#60
	move	sp_ypos+6*2,#170
	move	sp_colr+6*2,#15
	move	sp_flag+6*2,#$e6
	dmovi	sp_poin+6*2,handsp
	move	sp_flag+6*3,#1
	sta	wr_main

	dmovi	mode,..mmain

..loop	jsr	updtim
	ldx	display 	;change page to display
	sta	page1,x
	txa
	eor	#1
	sta	display
	lda	workon
	eor	#$60
	sta	workon

	long	prmsec,erasp	;copy erase screen
	long	prmsec,draw	;draw sprites

	jsr	stick

	bit	sup
	beq	..nup

	sta	rd_aux
	sta	wr_aux
	lda	sp_ypos+2*6
	cmp	#15*8+2
	bcc	..ud

	sec
	sbc	#2
	sta	sp_ypos+2*6
	jmp	..ud

..nup	bit	sdown
	beq	..ndn

	sta	rd_aux
	sta	wr_aux
	lda	sp_ypos+2*6
	cmp	#23*8-3
	bcs	..ud

	clc
	adc	#2
	sta	sp_ypos+2*6

..ud	sta	rd_main
	sta	wr_main
	jmp	chktap

..ndn	bit	sleft
	beq	..nlft

	sta	rd_aux
	sta	wr_aux
	lda	sp_xpos+2*6
	beq	..ud

	dec	sp_xpos+2*6
	jmp	..ud

..nlft	bit	sright
	beq	..nrgt

	sta	rd_aux
	sta	wr_aux
	lda	sp_xpos+2*6
	cmp	#79
	beq	..ud

	inc	sp_xpos+2*6
	jmp	..ud

..nrgt	bit	strig
	beq	..ntrig

	sta	rd_aux
	lda	sp_ypos+2*6
	and	#$f8
	tay
	lda	scanlo,y
	sta	punt
	lda	scanhi,y
	ora	#$04
	sta	punt+1
	lda	sp_xpos+2*6
	lsr	a
	tay
	sta	rd_main

	lda	(punt),y
	sta	butn
	beq	..ntrig
	cmp	#9
	bcs	..ntowr

	ldx	tower16
	stx	stow
	sec
	sbc	#1
	asl	a
	asl	a
	asl	a
	asl	a
	sta	tower16
	jsr	smap
	jsr	copy_b

..sty1	jsr	stick
	bit	strig
	bne	..sty1

	move	tower16,stow
	jsr	smap
	jsr	copy_b
	jmp	chktap

..ntowr jmp	(mode)

..ntrig

chktap	lda	motion
	cmp	#20
	lbeq	..loop

	cmp	#18
	bne	..not_rewind

	lda	#0
	sta	played1

	lda	tapcnt
	lbeq	..skip

	dec	tapcnt
	jmp	outdeb

..not_rewind
	ldx	tapcnt
	cpx	#191
	lbcs	 ..skip		;at end of tape?
	cmp	#19
	beq	..play

;fast forward
	
	lda	#0
	sta	played1

	inc	tapcnt
	jmp	outdeb
..play
	lda	tapcnt	; PLAY stuff
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	tax
	lda	musics,x
	sta	shape
;do play
	lda	musics,x
	sta	playtmp
	ldx	tapcnt
	jsr	playm

	lda	tapcnt
	and	#31
	beq	..setmus
	cmp	#30
	bne	..notmus
	lda	played1
	ora	played
	sta	played
	jmp	..notmus
..setmus
	ldx	playtmp
	beq	..notmus
	lda	#1
..setlp	dex
	beq	..fixmus
	asl	a
	jmp	..setlp
..fixmus
	sta	played1
..notmus

	inc	tapcnt
	lda	shape
	asl	a
	clc
	adc	#42
	tax
	jmp	..dochp
outdeb
	ldx	#56
..dochp	jsr	chomp
	sta	wr_aux
	move	erbuff+$2c,#16
	sta	erbuff+$6c
	move	erbuff+$2d,#184
	sta	erbuff+$6d
	move	erbuff+$2e,#8
	sta	erbuff+$6e
	move	erbuff+$2f,#$e6
	sta	erbuff+$6f
	sta	wr_main

	lda	tapcnt
	and	#$03
	clc
	adc	#88
	sta	shape
	ldy	#17
	sty	row
	ldx	#16
	jsr	stamp
	lda	shape
	ldy	row
	ldx	#20
	jsr	stamp
	sta	wr_aux
	move	erbuff+$28,#16
	sta	erbuff+$68
	move	erbuff+$29,#$88
	sta	erbuff+$69
	move	erbuff+$2a,#16
	sta	erbuff+$6a
	move	erbuff+$2b,#$e6
	sta	erbuff+$6b
	sta	wr_main

	jsr	prtapc

..skip	jmp	..loop

*********************
*  Main panel mode  *
*********************

..mmain cmp	#15
	lbeq	..done

	cmp	#16
	bne	..ntap

	move	clock,#0
	move	row,#21
	move	column,#32
	move	lhght,#16
	move	lwidt,#4
	jsr	light

	ldx	#30
	jsr	chomp
	ldx	#40
	jsr	chomp
	jsr	copy_b
	jsr	prtapc
	dmovi	mode,..mtap
	jmp	chktap

..ntap	cmp	#17
	bne	..ncod

	move	row,#21
	move	column,#36
	move	lhght,#16
	move	lwidt,#4
	jsr	light

	ldx	#34
	jsr	chomp

	jsr	dnums

	jsr	copy_b
	dmovi	mode,..mcod
	jmp	chktap

..ncod	jmp	chktap

..done
	jsr	stick
	and	#$c0
	bne	..done

	sta	wr_aux
	move	sp_flag+6*2,#1
	sta	wr_main
	rts

*********************
*  Tape panel mode  *
*********************

..mtap	cmp	#15
	beq	..dodo
	cmp	#16
	bne	..tnof

..dodo	jmp	dopan

..tnof	cmp	#18
	bcc	..ntp

	sta	motion

..ntp	jmp	chktap

*********************
*  Code panel mode  *
*********************

..mcod	cmp	#15
	beq	..do2
	cmp	#17
	bne	..cnof

..do2	jmp	dopan

..cnof	cmp	#12
	bcs	..nupb
	ldx	#1
	stx	updown
	sec
	sbc	#9
..nupsk	pha
	tax
	jsr	nxcodu
	jsr	dnums
	pla
	tax
	ldy	numps,x
	jsr	snumd
..ndnb	jmp	chktap

..nupb	cmp	#15
	bcs	..ndnb
	ldx	#0
	stx	updown
	sec
	sbc	#12
	jmp	..nupsk

dopan	ENDPROC

********************************

nxcodu	PROC

	lda	pinpos,x
	bmi	..exit
	tay

	lda	#low(pins)
	clc
	adc	..ofs,x
	sta	to
	lda	#high(pins)
	adc	#0
	sta	to+1

..lp
	lda	updown
	beq	..dodn
	iny
	cpy	#10
	bcc	..ok
	ldy	#0
	jmp	..ok
..dodn	dey
	bpl	..ok
	ldy	#9

..ok	lda	(to),y
	beq	..lp

	tya
	sta	pinpos,x
..exit	rts

..ofs	db	0, 10, 20

nxcodu	ENDPROC
********************************

dnums	PROC

	lda	workon
	pha
	move	stone,#$60
	sta	workon

	move	row,#21
	move	column,#16

	ldy	#0
	ldx	#2

..peq	lda	pinpos,x
	cmp	corpin,x
	bne	..neq
	iny
..neq	dex
	bpl	..peq
	cpy	#3
	bne	..nall

;
; at this point he has the correct combination to unlock the door
;

;
; stamp the "done" message
;

	lda	#97		;done
	ldy	row
	ldx	column
	jsr	stamp
	lda	  #$ff
	sta	  unlock_flag
	jmp	..done

..nall
	lda	  #$00
	sta	  unlock_flag

	cpy	#0
	beq	..nnone

	lda	#96
	ldy	row
	ldx	column
	jsr	stamp
	jmp	..done

..nnone ldx	#34		; ID PANEL
	jsr	chomp

..done
	ldx	#36
	jsr	chomp

	move	spyofs,#$88
	move	counts,#2
	move	coll,#20

..looop ldx	counts
	ldy	pinpos,x
	bmi	..nxpin

	sta	rd_aux
	sta	wr_aux
	lda	#0
	sta	nxpcc+0
	sta	nxpcc+1
	lda	..clr,x
	sta	nxpcc+2
	lda	numps,x
	asl	a
	sta	spxofs
	lda	numslo,y
	sta	nxpcc+4
	lda	numshi,y
	sta	nxpcc+5

	dmovi	xsppoint,nxpcc

	sta	rd_main
	sta	wr_main
	ldx	spxofs
	ldy	spyofs
	long	prmsec,xdraw

..nxpin lda	coll
	sec
	sbc	#10
	sta	coll
	dec	counts
	bpl	..looop

	pla
	sta	workon
	rts

numps	db	14, 18, 22

	 public   unlock_flag
unlock_flag	  ds	   1

..clr	db	4, 7, 1

dnums	ENDPROC

********************************

snumd	PROC

	lda	updown
	bne	..ud1a
	move	orig,#$9f
	jmp	..ud1b
..ud1a	move	orig,#$80
..ud1b
	move	display,#1
	sta	page1
	move	..sml1+1,#$40
	move	..sml2+1,#$20

..lopo
	lda	updown
	bne	..ud2a
	move	scan,#$9f
	jmp	..ud2b
..ud2a	move	scan,#$80
..ud2b

;REMOVED VBL WAIT

	lda	display
	eor	#1
	sta	display
	tax
	sta	page1,x

	lda	..sml1+1
	eor	#$60
	sta	..sml1+1

	lda	..sml2+1
	eor	#$60
	sta	..sml2+1

..lopi	sta	rd_aux
	sta	wr_aux
	ldx	scan
	lda	scanlo,x
	sta	to
	lda	scanhi,x
..sml1	ora	#$20
	sta	to+1

	lda	updown
	bne	..ud4a
	dex
	bmi	..mid
	jmp	..ud4b
..ud4a
	inx
	cpx	#$a0
	bcc	..mid
..ud4b

	ldx	orig
	lda	scanlo,x
	sta	from
	lda	scanhi,x
	ora	#$60
	sta	from+1
	jmp	..do

..mid	lda	scanlo,x
	sta	from
	lda	scanhi,x
..sml2	ora	#$40
	sta	from+1

..do	lda	(from),y
	sta	(to),y
	iny
	lda	(from),y
	sta	(to),y
	dey

	sta	rd_main
	sta	wr_main
	lda	(from),y
	sta	(to),y
	iny
	lda	(from),y
	sta	(to),y
	dey

	lda	updown
	bne	..ud3a
	
	dec	scan
	bmi	..lopi

	dec	orig
	lbmi	..lopo
	jmp	..ud3b
..ud3a
	inc	scan
	lda	scan
	cmp	#$a0
	bcc	..lopi

	inc	orig
	lda	orig
	cmp	#$a0
	lbcc	..lopo
..ud3b
	sta	wr_aux
	move	erbuff+$21,#$80
	tya
	and	#$fe
	sta	erbuff+$20
	move	erbuff+$22,#32
	move	erbuff+$23,#$e6
	sta	erbuff+$27
	sta	erbuff+$67
	move	erbuff+$26,#8
	sta	erbuff+$66
	move	erbuff+$24,#16
	sta	erbuff+$64
	move	erbuff+$25,#168
	sta	erbuff+$65
	sta	wr_main
	move	workon,#$40
	rts

snumd	ENDPROC

********************************

light	PROC

	lda	row
	asl	a
	asl	a
	asl	a
	sta	scanl

	move	counts,lhght

	sta	rd_aux

..loopo ldx	scanl
	lda	scanlo,x
	sta	punt
	lda	scanhi,x
	ora	stone
	sta	punt+1

	lda	lwidt
	clc
	adc	column
	tay

..loopi dey
	sta	rd_main
	sta	wr_main
	lda	(punt),y
	ora	#$08
	sta	(punt),y
	dey
	lda	(punt),y
	ora	#$22
	sta	(punt),y
	iny
	sta	rd_aux
	sta	wr_aux
	lda	(punt),y
	ora	#$44
	sta	(punt),y
	dey
	lda	(punt),y
	ora	#$11
	sta	(punt),y
	cpy	column
	bne	..loopi

	inc	scanl
	dec	counts
	bne	..loopo

	sta	rd_main
	sta	wr_main
	rts

light	ENDPROC

******************************

prtapc	PROC

	move	hex,tapcnt
	move	hex+1,#0
	jsr	hexdec

	move	row,#15
	move	column,#18
	lda	decimal+1
	and	#$0f
	jsr	prtnum
	lda	decimal
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	jsr	prtnum
	lda	decimal
	and	#$0f
	jsr	prtnum
	rts

prtapc	ENDPROC

hexdec	PROC

	sed
	lda	#0
	sta	decimal
	sta	decimal+1

	ldx	#0

..loop	ror	hex+1
	ror	hex
	bcc	..nx

	lda	decimal
	clc
	adc	dadd,x
	sta	decimal
	lda	decimal+1
	adc	dadd+1,x
	sta	decimal+1

..nx	inx
	inx
	cpx	#30
	bcc	..loop
	cld
	rts

dadd	dw	$0001
	dw	$0002
	dw	$0004
	dw	$0008
	dw	$0016
	dw	$0032
	dw	$0064
	dw	$0128
	dw	$0256
	dw	$0512
	dw	$1024
	dw	$2048
	dw	$4096
	dw	$8192

hexdec	ENDPROC

******************************

prtime	PROC

	move	row,#15
	move	column,#16

	lda	timer+3
	and	#$0f
	jsr	prtnum
	lda	#10
	jsr	prtnum

	lda	timer+2
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	jsr	prtnum
	lda	timer+2
	and	#$0f
	jsr	prtnum
	lda	#10
	jsr	prtnum

	lda	timer+1
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	jsr	prtnum
	lda	timer+1
	and	#$0f
	jsr	prtnum
	rts


prtime	ENDPROC

******************************

prtnum	PROC

	asl	a
	asl	a
	asl	a
	tax

	lda	row
	asl	a
	asl	a
	asl	a
	sta	scan

	sta	rd_aux

	ldy	scan
	lda	scanlo,y
	sta	to
	sta	to2
	sta	to3
	lda	scanhi,y
	ora	#$20
	sta	to+1
	eor	#$60
	sta	to2+1
	ora	#$60
	sta	to3+1

..loop	sta	wr_aux
	ldy	column
	lda	nmsl,x
	sta	(to),y
	sta	(to2),y
	sta	(to3),y

	sta	wr_main
	lda	nmsr,x
	sta	(to),y
	sta	(to2),y
	sta	(to3),y

	inx
	add	to+1,4
	add	to2+1,4
	add	to3+1,4
	bpl	..loop

	sta	rd_main
	inc	column
	rts

prtnum	ENDPROC
	
;**************************************************************************
;*	Music
;**************************************************************************
;***music
;------------------------
; A contains the piece of music to play
; x contains the tape count
playm	proc
	sta	rd_aux

	stx	tmpx

	asl	a		;get piece pointer
	tax
	lda	musiseg,x
	sta	tmpp
	lda	musiseg+1,x
	sta	tmpp+1

	lda	tmpx
	and	#$1f
	tay	
	lda	(tmpp),y
	tax
	jsr	pmusic
	sta	rd_main
	rts
playm	endproc

;Play one note
;x contains the pitch
pmusic	proc
	lda	#4	;a was supposed to be passed with the 64th notes time
	sta	tmpx
..pm3lp
	lda	#255
	cpx	#$ff
	beq	..pm2lp
	lda	durcom,x
..pm2lp
	ldy	#34
	cpx	#$ff
	beq	..pm1lp
	ldy	tonetbl,x
	sta	$c030
..pm1lp
	dey
	bne	..pm1lp
	sec
	sbc	#1
	bne	..pm2lp
	dec	tmpx
	bne	..pm3lp
	rts	
pmusic	endproc

	SEG	maindata

tbutrow db	15,15,17,17,19,19,21,21
	db	15,15,15,18,18,18,21,21,21,20,20,20,20
tbutcol db	 0, 3, 0, 3, 0, 3, 0, 3
	db	28,32,36,28,32,36,28,32,36,13,16,22,19

tdotrow db	$a4, $a2, $9a, $92, $90, $92, $9a, $a2
tdotcol db	$10, $12, $13, $12, $10, $0e, $0d, $0e

sup	db	$01
sdown	db	$02
sleft	db	$04
sright	db	$08
strig	db	$c0

	END
