$chip(6502)
$paginate

	 %include macro.inc
	 %include secseg.inc

	 seg	  graph

	 extern   block_io,block_command,track,sector,read,write
	 extern   rd_main,wr_main,rd_aux,wr_aux,page1,page2
	 extern   set_side2,buf_start,buf_len,set_dhires
	 extern   clrtext,setxt40,txtline,indent,textout

	 public   save_game,restore_game


save_game	  proc
	 sta	  rd_main
	 sta	  wr_main

	 jsr	  clrtext
	 jsr	  setxt40

	 lda	  #$08
	 sta	  txtline
	 lda	  #$05
	 sta	  indent

	 lda	  #..l_query_mess
	 ldx	  #low ..query_mess
	 ldy	  #high ..query_mess

	 jsr	  textout


..CLR_KEY
	LDA	$c010		;CLEAR KEYBOARD STROBE

..WAIT_FOR_KEY
	LDA	$c000
	BPL	..WAIT_FOR_KEY

	CMP	#('Y' OR $80)	;WAS IT A CAPITAL "Y" ?
	BEQ	..do_save	;YEP
	CMP	#('y' OR $80)	;LOWER CASE "y" ?
	BEQ	..do_save	;YEP
	CMP	#('N' OR $80)	;CAP. "N" ?
	beq	..GO_AWAY	;YEP, SO GET OUT (BEQ)
	CMP	#('n' OR $80)	;"n" ?
	BNE	..CLR_KEY	;INVALID CHOICE
..GO_AWAY
	jmp	  ..exit

..do_save
	 jsr	  set_side2
	 jsr	  clrtext

	 lda	  #'B'
	 sta	  $60fd
	 lda	  #'E'
	 sta	  $60fe
	 lda	  #'L'
	 sta	  $60ff

	 lda	  #write
	 sta	  block_command

	 lda	  #$22
	 sta	  track
	 lda	  #$0e
	 sta	  sector

	 lda	  #$00
	 sta	  buf_start
	 sta	  buf_len
	 lda	  #$60
	 sta	  buf_start+1
	 lda	  #$01
	 sta	  buf_len+1

	 jsr	  block_io



..exit
	 rts

..query_mess
	 db	  "Do you want to save this game ?"
..l_query_mess	  equ	   $-..query_mess



save_game	  endproc






restore_game	  proc
	 sta	  rd_main
	 sta	  wr_main

	 jsr	  set_side2

	 lda	  #read
	 sta	  block_command

	 lda	  #$22
	 sta	  track
	 lda	  #$0e
	 sta	  sector

	 lda	  #$00
	 sta	  buf_start
	 sta	  buf_len
	 lda	  #$60
	 sta	  buf_start+1
	 lda	  #$01
	 sta	  buf_len+1

	 jsr	  block_io

	 lda	  $60fd
	 cmp	  #'B'
	 bne	  ..dont_restore
	 lda	  $60fe
	 cmp	  #'E'
	 bne	  ..dont_restore
	 lda	  $60ff
	 cmp	  #'L'
	 bne	  ..dont_restore


	 jsr	  clrtext
	 jsr	  setxt40

	 lda	  #$08
	 sta	  txtline
	 lda	  #$00
	 sta	  indent

	 lda	  #..l_query_mess
	 ldx	  #low ..query_mess
	 ldy	  #high ..query_mess

	 jsr	  textout


..CLR_KEY
	LDA	$c010		;CLEAR KEYBOARD STROBE

..WAIT_FOR_KEY
	LDA	$c000
	BPL	..WAIT_FOR_KEY

	CMP	#('Y' OR $80)	;WAS IT A CAPITAL "Y" ?
	BEQ	..do_restore	;YEP
	CMP	#('y' OR $80)	;LOWER CASE "y" ?
	BEQ	..do_restore	;YEP
	CMP	#('N' OR $80)	;CAP. "N" ?
	beq	..GO_AWAY	;YEP, SO GET OUT (BEQ)
	CMP	#('n' OR $80)	;"n" ?
	BNE	..CLR_KEY	;INVALID CHOICE
..GO_AWAY
	jmp	  ..dont_restore

..do_restore
	 lda	  #$00
	 beq	  ..exit

..dont_restore
	 lda	  #$ff

..exit
	 rts


..query_mess
	 db	  "Do you want to restore the saved game ?"
..l_query_mess	  equ	   $-..query_mess


restore_game	  endproc

	 end
