$Chip(6502)
$Title(Impossible Mission II)

**********************************************
*	Chart the characters onto bit_map    *
*	Entry parameters:		     *
*	    Expects Main memory selected     *
*	    Data is in text screen  (Main)   *
*	Self_modifying code (RAM only)	     *
**********************************************

	%include macro.inc
	%include prmseg.inc

	EXTERN	wr_aux, rd_aux, wr_main, rd_main
	EXTERN	scanlo, scanhi, page1, page2
	EXTERN	display(page0), workon, level(page0), tower16(page0)
	EXTERN	stone, chomp, setroom
	EXTERN	side, walkway, prmsec, clear, copy_2
	EXTERN	stick, elevstf
	EXTERN	f14,f23, prtime
	extern	soundflag

	PUBLIC	scroldn, scrolup, dmap,dot

	seg	page0

	double	dot

	SEG	temps

	single	ltow
	single	rtow
	double	punt	
	double	oldot
	double	to
	double	from1
	double	from2
	double	from3
	double	from4

	single	scand
	single	lstat
	single	rstat

	SEG	maincode

scroldn PROC

	lda	level
	cmp	#1
	bne	..normal
	rts
..normal
	jsr	iscrl

..godn
	sta	rd_main
	lda	level
	cmp	#1
	lbeq	..exit
	dec	level

	jsr	comgo

	move	scand,#0

	sta	rd_aux
	sta	wr_aux

..again
	ldx	#0

	lda	display
	eor	#1
	sta	display
	tay
	sta	page1,y

	lda	stone
	sta	..sm1+1
	eor	#$60
	sta	stone

..loops lda	scanlo+8,x
	sta	from1
	sta	from2
	sta	from3
	sta	from4
	lda	scanhi+8,x
..sm1	ora	#$20
	sta	from1+1
	sta	from2+1
	sta	from3+1
	sta	from4+1

..loope lda	scanlo,x
	sta	to
	lda	scanhi,x
	ora	stone
	sta	to+1

	jsr	mv

	sta	rd_main
	sta	wr_main

	bit	soundflag
	bmi	..noclk1
	lda	$c030
..noclk1

	jsr	mv

	sta	rd_aux
	sta	wr_aux

	inx
	cpx	#13*8
	bcs	..last

	jmp	..loops

..last	beq	..decis

	lda	from1+1
	clc
	adc	#4
	lbmi	..again
	sta	from1+1

	lda	from2+1
	clc
	adc	#4
	sta	from2+1

	lda	from3+1
	clc
	adc	#4
	sta	from3+1

	lda	from4+1
	clc
	adc	#4
	sta	from4+1

	jmp	..loope

..decis lda	scand
	lsr	a
	lsr	a
	and	#$fe
	clc
	adc	lstat
	tay
	lda	f14,y
	sta	from1
	lda	f14+1,y
	sta	from1+1
	lda	f23,y
	sta	from2
	lda	f23+1,y
	sta	from2+1

	lda	scand
	lsr	a
	lsr	a
	and	#$fe
	clc
	adc	rstat
	tay
	lda	f14,y
	sta	from4
	lda	f14+1,y
	sta	from4+1
	lda	f23,y
	sta	from3
	lda	f23+1,y
	sta	from3+1

	lda	scand
	and	#$1f
	bne	..nvo1

	inc	level
	lda	scand
	jsr	dmap
	jsr	cmap
	dec	level

..nvo1	lda	scand
	clc
	adc	#8
	sta	scand
;	lda	scand
	cmp	#16*8
	lbcc	..loope

	lda	lstat
	ora	rstat
	lbeq	..godn

	sta	rd_main
	sta	wr_main
	jsr	stick
	sta	rd_aux
	sta	wr_aux

	and	#2
	lbne	..godn

..exit	jmp	exscr

scroldn ENDPROC

scrolup PROC

	lda	level
	cmp	#13
	bne	..normal
	rts
..normal
	jsr	iscrl

..goup	
	sta	rd_main

	lda	level
	cmp	#13
	lbeq	..exit
	inc	level

	jsr	comgo

	move	scand,#17*8

	sta	rd_aux
	sta	wr_aux

..again
	ldx	#14*8-1

	lda	display
	eor	#1
	sta	display
	tay
	sta	page1,y

	lda	stone
	sta	..sm1+1
	eor	#$60
	sta	stone

..loops lda	scanlo-8,x
	sta	from1
	sta	from2
	sta	from3
	sta	from4
	lda	scanhi-8,x
..sm1	ora	#$20
	sta	from1+1
	sta	from2+1
	sta	from3+1
	sta	from4+1

..loope lda	scanlo,x
	sta	to
	lda	scanhi,x
	ora	stone
	sta	to+1

	jsr	mv

	sta	rd_main
	sta	wr_main

	bit	soundflag
	bmi	..noclk1
	lda	$c030
..noclk1

	jsr	mv

	sta	rd_aux
	sta	wr_aux

	cpx	#8
	beq	..decis
	bcc	..last
	dex
	jmp	..loops

..decis dex

	lda	scand
	lsr	a
	lsr	a
	and	#$fe
	clc
	adc	lstat
	tay
	lda	f14,y
	sta	from1
	lda	f14+1,y
	ora	#$1c
	sta	from1+1
	lda	f23,y
	sta	from2
	lda	f23+1,y
	ora	#$1c
	sta	from2+1

	lda	scand
	lsr	a
	lsr	a
	and	#$fe
	clc
	adc	rstat
	tay
	lda	f14,y
	sta	from4
	lda	f14+1,y
	ora	#$1c
	sta	from4+1
	lda	f23,y
	sta	from3
	lda	f23+1,y
	ora	#$1c
	sta	from3+1

	lda	scand
	and	#$1f
	bne	..nvo2

	lda	scand
	jsr	dmap
	jsr	cmap

..nvo2	lda	scand
	sec
	sbc	#8
	sta	scand
	jmp	..loope

..last	dex
	lda	from1+1
	sec
	sbc	#4
	cmp	#$60
	bcc	..realy
	sta	from1+1

	lda	from2+1
	sec
	sbc	#4
	sta	from2+1

	lda	from3+1
	sec
	sbc	#4
	sta	from3+1

	lda	from4+1
	sec
	sbc	#4
	sta	from4+1

	jmp	..loope

..realy lda	scand
	cmp	#$10
	lbcs	..again

	lda	lstat
	ora	rstat
	lbeq	..goup

	sta	rd_main
	sta	wr_main
	jsr	stick
	sta	wr_aux
	sta	rd_aux
	and	#1
	lbne	..goup

..exit	jmp	exscr

scrolup ENDPROC

mv	PROC

	lda	scand
	and	#$07
	bne	..nos

	nop
	nop
	nop

..nos	ldy	#0

	lda	(from1),y	; 0
	sta	(to),y
	iny
	lda	(from1),y	; 1
	sta	(to),y
	iny
	lda	(from1),y	; 2
	sta	(to),y
	iny
	lda	(from1),y	; 3
	sta	(to),y
	iny
	lda	(from1),y	; 4
	sta	(to),y
	iny
	lda	(from1),y	; 5
	sta	(to),y
	iny
	lda	(from1),y	; 6
	sta	(to),y
	iny
	lda	(from1),y	; 7
	sta	(to),y
	iny
	lda	(from2),y	; 8
	sta	(to),y
	iny
	lda	(from2),y	; 9
	sta	(to),y
	iny
	lda	(from2),y	; 10
	sta	(to),y
	iny
	lda	(from2),y	; 11
	sta	(to),y
	iny
	lda	(from2),y	; 12
	sta	(to),y
	iny
	lda	(from2),y	; 13
	sta	(to),y
	iny
	lda	(from2),y	; 14
	sta	(to),y
	iny
	lda	(from2),y	; 15
	sta	(to),y

	ldy	#24

	lda	(from3),y	; 24
	sta	(to),y
	iny
	lda	(from3),y	; 25
	sta	(to),y
	iny
	lda	(from3),y	; 26
	sta	(to),y
	iny
	lda	(from3),y	; 27
	sta	(to),y
	iny
	lda	(from3),y	; 28
	sta	(to),y
	iny
	lda	(from3),y	; 29
	sta	(to),y
	iny
	lda	(from3),y	; 30
	sta	(to),y
	iny
	lda	(from3),y	; 31
	sta	(to),y
	iny
	lda	(from4),y	; 32
	sta	(to),y
	iny
	lda	(from4),y	; 33
	sta	(to),y
	iny
	lda	(from4),y	; 34
	sta	(to),y
	iny
	lda	(from4),y	; 35
	sta	(to),y
	iny
	lda	(from4),y	; 36
	sta	(to),y
	iny
	lda	(from4),y	; 37
	sta	(to),y
	iny
	lda	(from4),y	; 38
	sta	(to),y
	iny
	lda	(from4),y	; 39
	sta	(to),y

	rts

mv	ENDPROC

dmap	PROC
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	clc
	adc	#22*8+5
	sta	ltow

	tya
	pha

	dmove	oldot,dot

	lda	level
	asl	a
	asl	a
	sta	rtow

	lda	ltow
	sec
	sbc	rtow
	tay
	lda	scanlo,y
	sta	dot
	lda	scanhi,y
	ora	stone
	sta	dot+1

	bit	side
	bmi	..lsid

	ldy	#20
	lda	oldot+1
	and	#$60
	beq	..noeras
	lda	(oldot),y
	and	#$1f
	sta	(oldot),y
..noeras
	lda	dot+1
	and	#$60
	beq	..dmen

	lda	(dot),y
	ora	#$60
	sta	(dot),y
	jmp	..dmen

..lsid	sta	rd_main
	sta	wr_main
	ldy	#17
	lda	oldot+1
	and	#$60
	beq	..noeras1

	lda	(oldot),y
	and	#$7c
	sta	(oldot),y
..noeras1
	lda	dot+1
	and	#$60
	beq	..noeras2
	lda	(dot),y
	ora	#$03
	sta	(dot),y
..noeras2
	sta	rd_aux
	sta	wr_aux

..dmen	pla
	tay
	rts

dmap	ENDPROC

*******************************

cmap	PROC

	tya
	pha

	ldy	#20

	bit	side
	bpl	..rsid

	ldy	#17
	sta	rd_main
	sta	wr_main

..rsid	move	punt,dot
	lda	dot+1
	eor	#$60
	sta	punt+1
	and	#$60
	beq	..nodotx1
	lda	(dot),y
	sta	(punt),y
..nodotx1
	move	punt,oldot
	lda	oldot+1
	eor	#$60
	sta	punt+1
	and	#$60
	beq	..nodotx2
	lda	(oldot),y
	sta	(punt),y
..nodotx2
	sta	rd_aux
	sta	wr_aux
	pla
	tay
	rts

cmap	ENDPROC

comgo	proc

	lda	#36*2
	sta	lstat
	sta	rstat

	ldx	level
	cpx	#1
	beq	..go

	lda	#0
	sta	lstat
	sta	rstat

	bit	side
	bmi	..lsd

	cpx	#13
	bne	..nop1

	move	rstat,#36

..nop1	txa
	ora	tower16
	tax
	lda	walkway-2,x
	and	#$40
	beq	..go

	move	lstat,#36
	jmp	..go

..lsd	cpx	#13
	bne	..nop2

	move	lstat,#36

..nop2	txa
	ora	tower16
	tax
	lda	walkway-2,x
	and	#$80
	beq	..go

	move	rstat,#36
..go	rts
comgo	endproc
exscr	proc
	move	stone,#$20
	lda	#0
	jsr	dmap
	jsr	cmap
	lda	dot+1
	eor	#$60
	sta	dot+1
	sta	rd_main
	sta	wr_main

	sta	page1
	move	display,#0
	move	workon,#$20
	long	prmsec,clear
	jsr	elevstf
	long	prmsec,copy_2
	jsr	prtime

	rts
exscr	endproc

iscrl	proc
	long	prmsec,clear
	ldx	#0	;shaft
	jsr	chomp

	move	display,#1
	sta	page1
	lda	#$40
	sta	stone

	ldx	#12	;shaft2
	jsr	chomp

	move	stone,#$60
	bit	side
	bmi	..ls

	ldx	#22	;scrldar
	jmp	..s

..ls	ldx	#20	;scrldal

..s	jsr	chomp
	move	stone,#$20
	rts
iscrl	endproc
	
	END
