$CHIP(6502)
$PAGINATE

	 %INCLUDE secseg.inc
	 %INCLUDE macro.inc

	 extern   secprm,score_sector,rd_main,wr_main,rd_aux,wr_aux
	 extern   stick_vector,read_stick_vector,potcnt,stick_flag
	 extern   bad_disk,l_bad_disk,bd_anykey,l_bd_anykey,rooms
	 extern   iocb_io_buff_pntr,iocb_track,iocb_sector,buf_start
	 extern   iocb_command,call_rwts,read,write,seek,buf_len
	 extern   track,sector,block_command,block_io,spdefs
	 extern   pot0_lo_thresh,pot0_hi_thresh,max_stick_val
	 extern   pot1_lo_thresh,pot1_hi_thresh,random

	 public   setxt40,set_dhires,textout,txtline,indent,joycal
	 public   clrtext,wait_fire,set_side2,get_tower_data

	SEG	temps

	single	  temp1
	single	  temp2
	double	TDBL1
	double	TDBL2


	 SEG	  GRAPH


set_side2	  proc
	 lda	  #low score_sector
	 sta	  iocb_io_buff_pntr
	 lda	  #high score_sector
	 sta	  iocb_io_buff_pntr+1

	 lda	  #$22
	 sta	  iocb_track
	 lda	  #$0f
	 sta	  iocb_sector

	 lda	  #read
	 sta	  iocb_command

	 jsr	  call_rwts
	 bcs	  ..try_again

..ck_for_correct_signature
	 lda	  score_sector+(12*8)+0
	 cmp	  #'R'
	 bne	  ..try_again
	 lda	  score_sector+(12*8)+1
	 cmp	  #'T'
	 bne	  ..try_again
	 lda	  score_sector+(12*8)+2
	 cmp	  #'U'
	 beq	  ..got_side2


..try_again

;
; tell the idiot to try the correct disk
;
	 jsr	  clrtext

	 jsr	  setxt40

	 lda	  #08
	 sta	  indent
	 lda	  #11
	 sta	  txtline

	 lda	  #l_bad_disk
	 ldx	  #low bad_disk
	 ldy	  #high bad_disk

	 jsr	  textout

	 lda	  #08
	 sta	  indent
	 lda	  #12
	 sta	  txtline

	 lda	  #l_bd_anykey
	 ldx	  #low bd_anykey
	 ldy	  #high bd_anykey

	 jsr	  textout


..wait_for_a_key
	 long	  secprm,stick_vector
	 cpx	  #$00
	 bne	  ..go_for_another
	 cmp	  #$00
	 beq	  ..wait_for_a_key

..go_for_another
	 jmp	  set_side2


..got_side2
	 rts


set_side2	  endproc




get_tower_data	  proc
;
; !!! save TOWER/16 in ..TOWER !!!
;
	 lsr	  a
	 lsr	  a
	 lsr	  a
	 lsr	  a
	 sta	  ..tower

	 sta	  rd_main
	 sta	  wr_main

	 jsr	  clrtext
	 jsr	  setxt40

..read_tower_n
	 jsr	  set_side2
	 jsr	  clrtext

	 lda	  #low rooms
	 sta	  buf_start
	 lda	  #high rooms
	 sta	  buf_start+1

	 lda	  #$00
	 sta	  buf_len
	 lda	  #$0f
	 sta	  buf_len+1

	 ldx	  ..tower

	 lda	  ..twr_trk,x
	 sta	  track
	 lda	  ..twr_sec,x
	 sta	  sector

	 lda	  #read
	 sta	  block_command

	 jsr	  block_io
	 bcs	  ..read_tower_n	     ;error, go set side 2
	 bcc	  ..read_tsm_n

..error_reading_tsm_n
	 jsr	  set_side2
	 jsr	  clrtext

..read_tsm_n
	 lda	  #$00			     ;load data to $2000
	 sta	  buf_start
	 lda	  #$20
	 sta	  buf_start+1

	 lda	  #$00
	 sta	  buf_len

	 ldx	  ..tower

	 lda	  ..tsm_trk,x
	 sta	  track
	 lda	  ..tsm_sec,x
	 sta	  sector
	 lda	  ..tsm_siz,x
	 sta	  buf_len+1

	 lda	  #read
	 sta	  block_command

	 jsr	  block_io
	 bcs	  ..error_reading_tsm_n      ;error, go set side 2

;
; move data to aux now
;
	 ldy	  ..tower
	 lda	  ..tsm_siz,y
	 tax

	 lda	  #$00
	 sta	  tdbl1
	 lda	  #$20
	 sta	  tdbl1+1

	 lda	  #low spdefs
	 sta	  tdbl2
	 lda	  #high spdefs
	 sta	  tdbl2+1

	 sta	  wr_aux

..outer_mv_lp
	 ldy	  #$00
..mvlp
	 lda	  (tdbl1),y
	 sta	  (tdbl2),y
	 dey
	 bne	  ..mvlp

	 inc	  tdbl1+1
	 inc	  tdbl2+1

	 dex
	 bne	  ..outer_mv_lp

	 sta	  wr_main

	 rts




..twr_trk	  db	   $00,$01,$01,$02,$03,$04,$05,$06
..twr_sec	  db	   $01,$00,$0f,$0e,$0d,$0c,$0b,$0a

..tsm_trk	  db	   $07,$09,$0b,$0d,$0f,$12,$14,$16
..tsm_sec	  db	   $09,$07,$06,$0e,$0e,$01,$01,$0c
..tsm_siz	  db	   $1e,$1f,$28,$20,$23,$20,$2b,$2b

..tower  ds	  1

get_tower_data	  endproc




CLRTEXT  PROC

;
; CLEAR THE 40 COLUMN TEXT SCREEN
;

	LDA	#$00
	STA	TXTLINE
	STA	INDENT
T_CLRLP
	LDX	#LOW T_SPACES
	LDY	#HIGH T_SPACES
	LDA	#L_T_SPACES
	JSR	TEXTOUT

	LDX	TXTLINE
	INX
	STX	TXTLINE
	CPX	#24
	BCC	T_CLRLP

	RTS

T_SPACES  DB	 "                                        "
L_T_SPACES	   EQU	  $-T_SPACES


CLRTEXT  ENDPROC

WAIT_FIRE	  PROC
;
; WAIT FOR RISING EDGE OF FIRE BUTTON PRESS
;
	 long	  secprm,stick_vector
	AND	#$F0		;CHECK FOR VALIDITY
	BNE	WAIT_FIRE	;NOT VALID
WF_PRESS
	 long	  secprm,stick_vector
	AND	#$c0
	Beq	WF_PRESS
WF_DONE
	RTS

WAIT_FIRE	  ENDPROC

SET_DHIRES	  PROC

	STA	$C05E
	STA	$C057
	STA	$C050
	STA	$C00D
	STA	$C000
	RTS

SET_DHIRES	  ENDPROC

SETXT40 	  PROC

	STA	$C054
	STA	$C000
	STA	$C05F
	STA	$C056
	STA	$C051
	STA	$C00C
	STA	$C052
	RTS

SETXT40 	  ENDPROC

;
; Text output subroutine
;
;	variable dictionary:
;
;		TDBL1		2 byte zero page, temporary
;		TDBL2		2 byte zero page, temporary
;
;	variables/registers passed :
;
;		TXTLINE 	1 byte absolute, passed from caller.
;				indicates what text line to print on.
;		INDENT		1 byte absolute, passed from caller.
;				indicates how far to indent.
;		"A"		length of string to be printed.
;		"X"		LSB of beginning address of string.
;		"Y"		MSB of beginning address of string.
;
;	BE WARNED !!!:
;	This routine does not wrap a string from the right edge of the
;	screen correctly !!! (no address checking)
;


TEXTOUT  PROC

	DEX
	STX	TDBL1		;LSB OF ADDRESS OF STRING
	CPX	#$FF
	BNE	ADROK
	DEY
ADROK
	STY	TDBL1+1 	;MSB
	TAY			;LENGTH

	LDA	TXTLINE 	;TEXT LINE TO PRINT ON (0-23)
	ASL	A		;*2 FOR WORD INDEXING
	TAX
	LDA	TXTSTAB+1,X	;TEXT LINE LOOK UP
	STA	TDBL2+1
	LDA	TXTSTAB,X
	CLC
	ADC	INDENT
	SEC
	SBC	#$01
	STA	TDBL2
	LDA	TDBL2+1
	SBC	#$00
	STA	TDBL2+1


TOLP
	LDA	(TDBL1),Y
	ora	  #$80
	STA	(TDBL2),Y
	DEY
	BNE	TOLP

	RTS

TEXTOUT  ENDPROC

JOYCAL	 PROC

;
; JOYSTICK CALIBRATION ROUTINE
;

	JSR	SETXT40
	JSR	CLRTEXT

	LDX	#$00
	JSR	CAL_PRN
	LDX	#$01
	JSR	CAL_PRN
	LDX	#$02
	JSR	CAL_PRN

CLR_KEY
	LDA	$c010		;CLEAR KEYBOARD STROBE

WAIT_FOR_KEY
	jsr	random
	LDA	$c000
	BPL	WAIT_FOR_KEY

	CMP	#('Y' OR $80)	;WAS IT A CAPITAL "Y" ?
	BEQ	GO_CALIBRATE	;YEP
	CMP	#('y' OR $80)	;LOWER CASE "y" ?
	BEQ	GO_CALIBRATE	;YEP
	CMP	#('N' OR $80)	;CAP. "N" ?
	beq	GO_AWAY 	;YEP, SO GET OUT (BEQ)
	CMP	#('n' OR $80)	;"n" ?
	BNE	CLR_KEY 	;INVALID CHOICE
GO_AWAY
	LDA	#$80		;INDICATE NO JOYSTICK
	STA	STICK_FLAG

	JMP	FINI_CAL	;HE HAS NO JOYSTICK

GO_CALIBRATE
	LDA	#$00		;INDICATE JOYSTICK IN USE
	STA	STICK_FLAG

	JSR	CLRTEXT

	LDX	#$03
	JSR	CAL_PRN
	LDX	#$04
	JSR	CAL_PRN
	LDX	#$06
	JSR	CAL_PRN
	LDX	#$07
	JSR	CAL_PRN
	LDX	#$08
	JSR	CAL_PRN
	LDX	#$09
	JSR	CAL_PRN

	LDA	#$01
	STA	CAL_TEMP2

	JSR	WAIT_FIRE		;WAIT FOR FIRE BUTTON

	LDX	#$FF
	STX	POT0_MIN
	STX	POT1_MIN
	INX
	STX	POT0_MAX
	STX	POT1_MAX

CAL_BIGLP
	LDX	#$00

CAL_LOOP
	STX	CAL_TEMP1

;	JSR	READ_STICK
	 long	  secprm,read_stick_vector

	LDA	POTCNT
	LDY	POTCNT+1

	LDX	CAL_TEMP2
	BEQ	CAL_POT0_LR

CAL_POT0_UL
	CMP	POT0_MIN
	BCS	CAL_POT1_UL
	STA	POT0_MIN
	LDX	#$00
	STX	CAL_TEMP1
	JMP	CAL_POT1_UL

CAL_POT0_LR
	CMP	POT0_MAX
	BCC	CAL_POT1_LR
	BEQ	CAL_POT1_LR
	STA	POT0_MAX
	LDX	#$00
	STX	CAL_TEMP1
	JMP	CAL_POT1_LR

CAL_POT1_UL
	CPY	POT1_MIN
	BCS	CAL_LOOP_LOG
	STY	POT1_MIN
	LDX	#$00
	STX	CAL_TEMP1
	JMP	CAL_LOOP_LOG

CAL_POT1_LR
	CPY	POT1_MAX
	BCC	CAL_LOOP_LOG
	BEQ	CAL_LOOP_LOG
	STY	POT1_MAX
	LDX	#$00
	STX	CAL_TEMP1

CAL_LOOP_LOG
	LDX	CAL_TEMP1
	DEX
	BNE	CAL_LOOP

	LDY	CAL_TEMP2
	BNE	CAL_PR_UPERL
	JMP	CAL_THRESH

CAL_PR_UPERL
	LDX	#$05
	JSR	CAL_PRN

	JSR	WAIT_FIRE

	DEC	CAL_TEMP2
	JMP	CAL_BIGLP

;
; CALCULATE LOW-MIDDLE-HIGH RESISTANCE THRESHOLDS FOR CONVERSION TO "DIGITAL"
;
CAL_THRESH
	SEC				;CALCUALTE POT0 RANGE
	LDA	POT0_MAX
	SBC	POT0_MIN
	STA	POT0_RANGE

	SEC				;CALCULATE POT1 RANGE
	LDA	POT1_MAX
	SBC	POT1_MIN
	STA	POT1_RANGE

	LSR	A
	LSR	A
	PHA
	STA	POT1_LO_THRESH

	SEC
	LDA	POT1_RANGE
	SBC	POT1_LO_THRESH
	CLC
	ADC	POT1_MIN
	STA	POT1_HI_THRESH

	CLC
	PLA
	LSR	A
	ADC	POT1_MIN
	STA	POT1_LO_THRESH

; NOW DO POT0 STUFF

	LDA	POT0_RANGE
	LSR	A
	LSR	A
	PHA
	STA	POT0_LO_THRESH

	SEC
	LDA	POT0_RANGE
	SBC	POT0_LO_THRESH
	CLC
	ADC	POT0_MIN
	STA	POT0_HI_THRESH

	CLC
	PLA
	LSR	A
	ADC	POT0_MIN
	STA	POT0_LO_THRESH


	LDA	POT0_MAX
	CMP	POT1_MAX
	BCS	CAL_STORE_MAX

	LDA	POT1_MAX

CAL_STORE_MAX
	STA	MAX_STICK_VAL

	LDA	MAX_STICK_VAL		;MAX_STICK_VAL * 0.75
	STA	TDBL1
	LDA	#$00
	STA	TDBL1+1

	ASL	TDBL1			;MAX_STICK_VAL * 4 ...
	ROL	TDBL1+1
	ASL	TDBL1
	ROL	TDBL1+1

	SEC				;... - MAX_STICK_VAL ...
	LDA	MAX_STICK_VAL
	SBC	TDBL1
	STA	TDBL1
	LDA	#$00
	SBC	TDBL1+1

	LSR	A			;... MAX_STICK_VAL / 4
	STA	TDBL1+1
	ROR	TDBL1
	LSR	TDBL1+1
	LDA	TDBL1
	ROR	A
	STA	MAX_STICK_VAL

FINI_CAL

	JSR	CLRTEXT
	RTS

CAL_PRN
	LDA	CAL_T_LIN,X
	STA	TXTLINE
	LDA	CAL_IND,X
	STA	INDENT

	TXA
	ASL	A
	TAX

	LDA	CAL_AD,X
	STA	TEMP1
	LDA	CAL_AD+1,X
	TAY
	TXA
	LSR	A
	TAX
	LDA	CAL_L,X
	LDX	TEMP1

	JSR	TEXTOUT

	RTS

JOYCAL	 ENDPROC


TXTLINE  DS	1
INDENT	 DS	1

TXTSTAB
	 DW	$0400,$0480,$0500,$0580,$0600,$0680,$0700,$0780
	 DW	$0428,$04A8,$0528,$05A8,$0628,$06A8,$0728,$07A8
	 DW	$0450,$04D0,$0550,$05D0,$0650,$06D0,$0750,$07D0


CAL_TEMP1	 DS	1
CAL_TEMP2	 DS	1

;POT0_HI_THRESH   DS	 1
;POT0_LO_THRESH   DS	 1
POT0_MAX	 DB	$FF
POT0_MIN	 DB	$00
POT0_RANGE	 DS	1

;POT1_HI_THRESH   DS	 1
;POT1_LO_THRESH   DS	 1
POT1_MAX	 DB	$FF
POT1_MIN	 DB	$00
POT1_RANGE	 DS	1

;MAX_STICK_VAL	  DB	 $FF

CAL_AD
	 DW	J_QUERY1,J_QUERY2,J_QUERY3
	 DW	J_CAL1,J_CAL2,J_CAL3,J_CAL4,J_CAL5,J_CAL6,J_CAL7,J_CAL8
CAL_L
	 DB	L_J_QUERY1,L_J_QUERY2,L_J_QUERY3
	 DB	L_J_CAL1,L_J_CAL2,L_J_CAL3,L_J_CAL4
	 DB	L_J_CAL5,L_J_CAL6,L_J_CAL7,L_J_CAL8

CAL_T_LIN
	 DB	10,12,13,2,10,10,19,20,21,22,23,17

CAL_IND
	 DB	7,16,16,6,14,14,2,2,2,2,11,10

J_QUERY1
	 DB	"DO YOU HAVE A JOYSTICK ?"	;INDENT TO 8
L_J_QUERY1	 EQU	$-J_QUERY1
J_QUERY2
	 DB	"Y) YES"			;INDENT TO 17
L_J_QUERY2	 EQU	$-J_QUERY2
J_QUERY3
	 DB	"N) NO" 			;INDENT TO 17
L_J_QUERY3	 EQU	$-J_QUERY3
J_CAL1
	 DB	"** JOYSTICK CALIBRATION **"
L_J_CAL1	 EQU	$-J_CAL1
J_CAL2
	 DB	"UPPER LEFT"
L_J_CAL2	 EQU	$-J_CAL2
J_CAL3
	 DB	"LOWER RIGHT"
L_J_CAL3	 EQU	$-J_CAL3
J_CAL4
	 DB	"Please hold stick at position shown"
L_J_CAL4	 EQU	$-J_CAL4
J_CAL5
	 DB	"Push action button and then release"
L_J_CAL5	 EQU	$-J_CAL5
J_CAL6
	 DB	"Hold stick at this position until"
L_J_CAL6	 EQU	$-J_CAL6
J_CAL7
	 DB	"position request changes"
L_J_CAL7	 EQU	$-J_CAL7
J_CAL8
	 DB	'Press "Q" to QUIT'
L_J_CAL8	 EQU	$-J_CAL8
J_CAL9	 DB	'*** CALIBRATING ***'
L_J_CAL9	 EQU	$-J_CAL9

	 END

