$chip(6502)
$paginate

	 %include secseg.inc

	 %include macro.inc

	 seg	  graph

	 extern   soundflag,rd_main

	 public   scream,fizzle,footstep,boom,random

speaker  equ	  $c030

sound	 proc

scream
	 sta	  rd_main
	 bit	  soundflag
	 lbmi	  ..exit

	 lda	  #$04
	 sta	  ..freq		     ;start w/ high freq.

..screamloop
	 lda	  ..freq
	 sta	  ..tonecount

	 jsr	  random
	 and	  #%00010101
	 sta	  ..noisecount

..ck_for_click_lp
	 lda	  #$00
	 sec
	 sbc	  ..tonecount
	 tax
	 ldy	  ..tonecount

..inner_loop
;	 jsr	  ..dumb_wait		     ;!!!!!!!!!!!!!!!!

	 dey
	 bne	  ..even_up_timing1
	 bit	  speaker
	 ldy	  ..tonecount
	 jmp	  ..ck_random_click

..even_up_timing1
	 pha
	 pla

..ck_random_click
	 stx	  ..tx
	 sty	  ..ty
	 jsr	  random
	 ldx	  ..tx
	 ldy	  ..ty
	 and	  ..freq

	 dec	  ..noisecount
	 bpl	  ..even_up_timing2

	 sta	  ..noisecount
	 bit	  speaker
	 jmp	  ..outer_loop_logic

..even_up_timing2
	 pha
	 pla
	 nop
	 nop

..outer_loop_logic
	 dex
	 bne	  ..inner_loop

	 inc	  ..freq
	 lda	  ..freq

	 cmp	  #$40
	 bcs	  ..exit

	 sta	  ..tonecount
	 jmp	  ..inner_loop



..exit
	 rts


***************************************************


fizzle
	 sta	  rd_main
	 bit	  soundflag
	 lbmi	  ..exit

	 lda	  #$03
	 sta	  ..tonecount

..buzzlp
	 ldx	  #$10

..inner_buzz
	 stx	  ..tx
	 jsr	  random
	 ldx	  ..tx
	 and	  #$03

	 dec	  ..noisecount
	 bpl	  ..even_up_timing3

	 sta	  ..noisecount
	 bit	  speaker
	 jmp	  ..ck_for_more_noise

..even_up_timing3
	 pha
	 pla
	 nop
	 nop

..ck_for_more_noise
	 dex
	 bpl	  ..inner_buzz

	 ldx	  #$0f

..dumb_wait_loop
	 jsr	  ..stupid_waste_of_time
	 dex
	 bne	  ..dumb_wait_loop
	 dec	  ..tonecount
	 bne	  ..buzzlp
	 beq	  ..exit

..stupid_waste_of_time
	 jsr	  $+3
	 jsr	  $+3
	 jsr	  $+3
	 jsr	  $+3
	 jsr	  $+3
	 rts



******************************************************

footstep
	 sta	  rd_main
	 bit	  soundflag
	 lbmi	  ..exit


	 ldx	  #$05
..thump_outer_loop
	 ldy	  #$00
	 bit	  speaker
..thump_inner_loop
	 dey
	 bne	  ..thump_inner_loop
	 dex
	 bne	  ..thump_outer_loop

	 jmp	  ..exit


******************************************************

boom
	 sta	  rd_main
	 bit	  soundflag
	 lbmi	  ..exit

	 ldx	  #$01
	 stx	  ..freq
	 dex
	 stx	  ..noisecount

..boom_loop
	 ldx	  #$60
	 stx	  ..tonecount

..inner_boom
	 jsr	  random
	 and	  ..freq

	 dec	  ..noisecount
	 bpl	  ..even_up_timing4

	 sta	  ..noisecount
	 bit	  speaker
	 jmp	  ..ck_for_more_noise2

..even_up_timing4
	 pha
	 pla
	 nop
	 nop

..ck_for_more_noise2
	 dec	  ..tonecount
	 bpl	  ..inner_boom
	 inc	  ..freq
	 lda	  ..freq
	 cmp	  #$10
	 bcc	  ..boom_loop
	 jmp	  ..exit

..freq		  ds	   1
..tonecount	  ds	   1
..noisecount	  ds	   1
..tx		  ds	   1
..ty		  ds	   1
..wait_count	  ds	   1
..bounce_tempo
		  db	   $18,$20,$20,$3d,$6c,$c0
;		  db	   $20,$28,$28,$45,$70,$70

sound	 endproc


******************************************************


random	proc
	 sec
	 lda	 ..noisepad+1
	 adc	 ..noisepad+4
	 adc	 ..noisepad+5
	 sta	 ..noisepad
	 ldy	 #$04
..noiseloop
	 lda	 ..noisepad,y
	 sta	 ..noisepad+1,y
	 dey
	 bpl	 ..noiseloop

	 rts
..noisepad	  ds	   6

random	endproc

	 end
