$Chip(6502)
$Title(Impossible Mission II)
$Subtitle(Put up stamp objects)
$Paginate
$Indent=8

	%include macro.inc
	%include prmseg.inc

	EXTERN	wr_aux, rd_aux, wr_main, rd_main
	EXTERN	sshape, rmptr
	EXTERN	scanlo, scanhi

	PUBLIC	stamp, chomp
	PUBLIC	stone

	SEG	PAGE0

	single	stone

	single	cnt

	double	bitmap
	double	spoint

	single	scanp
	single	scanc
	single	countp
	single	byte

	seg	temps
	single	row
	single	column
	single	shape
	single	crow
	single	ccolumn
	single	cshape
	single	xoff
	single	yoff
	double	rpoint

	SEG	maincode

**********************************************
*	Stamp primitive shapes in columns    *
*  Input parameters: (zero page locations)   *
*	Yrow:	character row (0-23)	     *
*	Xcolumn: graphics column (0-19)*2     *
*	Ashape:	shape number (0-??)	     *
*		Table can be found in	     *
*		rooms.asm (sshape)	     *
*	stone:	High byte of the beginning   *
*		of the screen written to.    *
*  Expects Main bank for read & write	     *
*  Returns in same condition.		     *
*  Input values not modified.		     *
*  Format for data in table is in rooms.asm  *
**********************************************

stamp	PROC

	sta	shape
	stx	column
	sty	row
	lda	shape
	asl	a
	tax
	lda	sshape,x
	sta	spoint
	lda	sshape+1,x
	sta	spoint+1

	lda	column
	pha

	ldy	#0
	lda	(spoint),y
	sta	scanc

	move	countp,#0

..mloop
	sta	wr_aux
	jsr	stampsub
	sta	wr_main
	jsr	stampsub
	inc	column
	sta	wr_aux
	jsr	stampsub
	sta	wr_main
	jsr	stampsub

..dune	sta	wr_main
	sta	rd_main

	inc	column
	dec	scanc
	lbne	..mloop

	pla
	sta	column
	rts

stampsub
	lda	row
	asl	a
	asl	a
	asl	a
	sta	scanp

	dinc	spoint

..lp1	sta	rd_main
	ldx	#0
	lda	(spoint,x)
	sta	rd_aux
	bpl	..norm1

	and	#$7f
	beq	..part2
	sta	countp
	jmp	..nx1

..norm1 sta	byte

..ins1	ldy	scanp
	lda	scanlo,y
	sta	bitmap
	lda	scanhi,y
	ora	stone
	sta	bitmap+1

	lda	byte
	ldy	column
	sta	(bitmap),y

	inc	scanp
	lda	countp
	beq	..nx1
	dec	countp
	bne	..ins1

..nx1	dinc	spoint
	jmp	..lp1

..part2 rts

stamp	ENDPROC

chomp	PROC

	lda	rmptr,x
	sta	rpoint
	lda	rmptr+1,x
	sta	rpoint+1

..dagn	ldy	#3
	lda	(rpoint),y
	bne	..goon

	rts

..goon	sta	cnt
	iny
	lda	(rpoint),y
	sta	xoff
	iny
	lda	(rpoint),y
	sta	yoff
	ldy	#0
	lda	(rpoint),y
	sta	crow
	iny
	lda	(rpoint),y
	sta	ccolumn
	iny
	lda	(rpoint),y
	sta	cshape

..loop
	lda	cshape
	ldy	crow
	ldx	ccolumn
	jsr	stamp

	lda	crow
	clc
	adc	xoff
	sta	crow

	lda	ccolumn
	clc
	adc	yoff
	sta	ccolumn

	dec	cnt
	bne	..loop

	dadd	rpoint,6
	jmp	..dagn

chomp	ENDPROC

	END
