$chip(6502)
$title(Impossible Mission 2)
$paginate
$indent=8
**********************************************
*					     *
**********************************************

	%include macro.inc
	%include secseg.inc

	public	dobmb1,reslfts

	extern	lifts,n_lifts,sfloors,n_sfloors
	extern	rd_main,wr_main,rd_aux,wr_aux
	extern	bmbimg,xsppoint,xdraw,scanlo,scanhi,holes,nxpcc

	seg	temps
;for bomb sprite writing
	single	tx1
	single	ty1
	single	ttb
	single	joytmp
	double	bitmap

	seg	graph
	
;******************************************
;reset lifts from terminal or death routine
reslfts	proc
	public	reslfts
	ldy	n_lifts
	beq	..reslxit
	ldx	#0
..rllp
	lda	lifts+6,x
	sta	lifts+3,x
	sta	joytmp
	txa
	clc
	adc	joytmp
	sty	joytmp
	tay
	lda	lifts+2,x
	beq	..rshl
	

	lda	lifts+9,y	;set y pos
	sta	lifts+1,x
	lda	lifts+8,x
	sta	lifts,x
	jmp	..rsvle
..rshl
	lda	lifts+9,y	;set y pos
	sta	lifts,x
	lda	lifts+8,x
	sta	lifts+1,x

..rsvle
	ldy	joytmp
	txa
	clc
	adc	#18
	tax
	dey
	bne	..rllp
..reslxit
	rts

reslfts	endproc

;resflrs	proc
;	ldy	n_sfloors
;	beq	..eend
;..lp	lda	sfloors+3,x
;	sta	sfloors,x
;	inx
;	inx
;	inx
;	inx
;	dey
;	bne	..lp
;..eend	rts
;resflrs	endproc

;****************************************
dobmb1	proc
	
dobmb
	sta	rd_aux
	sta	wr_aux
	stx	tx1
	sty	ty1
	sta	ttb
	and	#$f
	sta	nxpcc+2	;set color based on type

	lda	tx1
	and	#$80
	lbne	..endbmb

	lda	ttb

	and	#$80
	bne	..bmbrt
	lda	tx1
	sec
	sbc	#8	;8
	bcc	..bmblf
	lda	#0
..bmbrt
	lda	tx1
	sec
	sbc	#4	;2
..bmblf
	sta	nxpcc

	lda	ttb
	and	#$f
	cmp	#2	;time bomb - don't mark coll scrn
	lbeq	..nomrk


	ldy	#0
..hllp2	lda	holes,y
	cmp	#0
	bne	..fndhl1
..hllp1	iny
	iny
	iny
	cpy	#24
	bne	..hllp2
	jmp	..nocpy
..fndhl1
	lda	ty1
	sec
	sbc	#4		;offset for actual floor
	and	#$f8
	lsr	a
	lsr	a
	lsr	a
	cmp	holes+2,y
	bne	..hllp1

	lda	nxpcc
	lsr	a
	clc
	adc	#3
	cmp	holes+1,y
	bne	..hllp1
	jmp	..endbmb
..nocpy


	ldy	#0
..hllp	lda	holes,y
	cmp	#0
	beq	..fndhl
	iny
	iny
	iny
	cpy	#24
	bne	..hllp
	jmp	..endbmb
..fndhl

	lda	ty1
	sec
	sbc	#4		;offset for actual floor
	and	#$f8
	lsr	a
	lsr	a
	lsr	a
	sta	holes+2,y

	lda	nxpcc
	lsr	a
	clc
	adc	#3
	sta	holes+1,y

	lda	ttb
	and	#$7f
	sta	holes,y

	lda	ty1
	sec
	sbc	#4		;offset for actual floor
	and	#$f8
	tay

;get x for use as an index
	lda	nxpcc
	lsr	a
	tax
	inx
	inx
	inx
	lda	scanlo,y	;use scan table to find collision position
	sta	bitmap
	lda	scanhi,y
	clc
	adc	#$04
	sta	bitmap+1
	txa
	tay
	sta	rd_main
	sta	wr_main
	lda	(bitmap),y       ;get value at the bitmap
	ora	#$20
	sta	(bitmap),y       ;set bomb bit
	lda	ttb
	cmp	#4
	bne	..norob
	lda	ty1
	sec
	sbc	#4
	sta	ty1	
	lda	(bitmap),y       ;get value at the bitmap
	ora	#$40
	sta	(bitmap),y       ;set bomb bit
	jmp	..xxrob
..norob
	lda	(bitmap),y       ;get value at the bitmap
	and	#$bf
	sta	(bitmap),y       ;set bomb bit
..xxrob
	sta	wr_aux
	sta	rd_aux

..nomrk
	lda	ty1
	sec
	sbc	#5
	sta	nxpcc+1
	lda	#$e6
	sta	nxpcc+3
	lda	#low(bmbimg)
	sta	nxpcc+4
	lda	#high(bmbimg)
	sta	nxpcc+5
	lda	#low nxpcc
	sta	xsppoint
	lda	#high nxpcc
	sta	xsppoint+1
	ldy	#0
	ldx	#0
	jsr	xdraw
..endbmb
	sta	rd_main
	sta	wr_main
	rts
dobmb1	endproc
	end
