$chip(6502)


	 %include secseg.inc
	 %include macro.inc


	 extern   rwts,iocb_io_buff_pntr,iocb_track,iocb_sector
	 extern   iocb_command,call_rwts,total_pins
	 extern   timer,pins,setxt40,clrtext,indent,txtline,textout
	 extern   stick_vector,secprm,towrcomp,init,sounds
	 extern   rd_main,wr_main,wait_fire,scanlo,scanhi,rd_aux,wr_aux

	 public   score_screen,score_sector,bad_disk,l_bad_disk
	 public   bd_anykey,l_bd_anykey

seek	 equ	  $00
read	 equ	  $01
write	 equ	  $02



	 seg	  temps

temp1	 ds	  1
temp2	 ds	  1
tdbl1	 ds	  2
tdbl2	 ds	  2





	 seg	  graph

score_screen	    proc
	 sta	  rd_main
	 sta	  wr_main

	 lda	  #$00
	 sta	  ..bcd_total_score+0
	 sta	  ..bcd_total_score+1
	 sta	  ..bcd_total_score+2
	 sta	  tdbl1
	 sta	  tdbl1+1
	 sta	  tdbl2
	 sta	  tdbl2+1

	 cld


	 dmove	  hex,total_pins

	 jsr	  hexdec

	 dmove	  ..bcd_total_pins,decimal



;
; sum the number of objects
;

	 ldx	  #05
..obj_sum_loop
	 clc
	 lda	  pins+30,x
	 adc	  tdbl1
	 sta	  tdbl1
	 bcc	  ..obj_sum_loop_logic
	 inc	  tdbl1+1

..obj_sum_loop_logic
	 dex
	 bpl	  ..obj_sum_loop

	 dmove	  hex,tdbl1
	 jsr	  hexdec
	 dmove	  ..bcd_obj_found,decimal

	 asl	  tdbl1
	 rol	  tdbl1+1

	 dmove	  hex,tdbl1
	 jsr	  hexdec
	 dmove	  ..bcd_obj_score,decimal


;
; calculate musics score
;
	 move	  hex,sounds
	 move	  hex+1,#$00
	 jsr	  hexdec

	 dmove	  ..bcd_music,decimal

	 cld

	 lda	  sounds
	 asl	  a
	 clc
	 adc	  sounds
	 sta	  hex
	 lda	  #$00
	 sta	  hex+1

	 jsr	  hexdec
	 dmove	  ..bcd_music_score,decimal



;
; calculate towers score
;
	 move	  hex,towrcomp
	 move	  hex+1,#$00
	 jsr	  hexdec
	 move	  ..bcd_towrcomp,decimal


	 lda	  towrcomp
	 asl	  a
	 sta	  hex
	 lda	  #$00
	 sta	  hex+1
	 jsr	  hexdec

	 ldx	  #$03
..lp1
	 asl	  decimal
	 rol	  decimal+1
	 dex
	 bpl	  ..lp1

	 dmove	  ..bcd_towers_score,decimal


calctime
	 sed

	 lda	  timer+3
	 sta	  ..bcd_buff1
	 lda	  #$0
	 sta	  ..bcd_buff1+1
	 sta	  ..bcd_buff1+2
	 jsr	  ..xsixtydec

	 sed
	 clc
	 lda	  timer+2
	 adc	  ..bcd_buff1
	 sta	  ..bcd_buff1
	 lda	  #$00
	 adc	  ..bcd_buff1+1
	 sta	  ..bcd_buff1+1
	 lda	  #$00
	 adc	  ..bcd_buff1+2
	 sta	  ..bcd_buff1+2
	 jsr	  ..xsixtydec

	 dmove	  ..bcd_time_score,..bcd_buff1
	 move	  ..bcd_time_score+2,..bcd_buff1+2

	 sed

	 clc
	 lda	  timer+1
	 adc	  ..bcd_time_score+0
	 sta	  ..bcd_time_score+0
	 lda	  #$00
	 adc	  ..bcd_time_score+1
	 sta	  ..bcd_time_score+1
	 lda	  #$00
	 adc	  ..bcd_time_score+2
	 sta	  ..bcd_time_score+2




;
; calculate total score
;
totscore
	 dmove	  ..bcd_total_score+1,..bcd_total_pins

	 clc
	 sed

	 lda	  ..bcd_total_score+1
	 adc	  ..bcd_obj_score
	 sta	  ..bcd_total_score+1
	 lda	  ..bcd_total_score+2
	 adc	  ..bcd_obj_score+1
	 sta	  ..bcd_total_score+2

	 clc
	 lda	  ..bcd_total_score+1
	 adc	  ..bcd_music_score
	 sta	  ..bcd_total_score+1
	 lda	  ..bcd_total_score+2
	 adc	  ..bcd_music_score+1
	 sta	  ..bcd_total_score+2

	 clc
	 lda	  ..bcd_total_score+1
	 adc	  ..bcd_towers_score
	 sta	  ..bcd_total_score+1
	 lda	  ..bcd_total_score+2
	 adc	  ..bcd_towers_score+1
	 sta	  ..bcd_total_score+2

	 clc
	 lda	  ..bcd_total_score+0
	 adc	  ..bcd_time_score+0
	 sta	  ..bcd_total_score+0
	 lda	  ..bcd_total_score+1
	 adc	  ..bcd_time_score+1
	 sta	  ..bcd_total_score+1
	 lda	  ..bcd_total_score+2
	 adc	  ..bcd_time_score+2
	 sta	  ..bcd_total_score+2

	 cld

;
;
; set 40 column text mode & clear the screen
;
;

	 jsr	  setxt40

	 jsr	  clrtext



****************************************

	 lda	  #$00
	 sta	  ..scores_flag

	 lda	  #03
	 sta	  ..read_attempts

..read_scores_from_disk
	 lda	  #low score_sector
	 sta	  iocb_io_buff_pntr
	 lda	  #high score_sector
	 sta	  iocb_io_buff_pntr+1

	 lda	  #$22
	 sta	  iocb_track
	 lda	  #$0f
	 sta	  iocb_sector

	 lda	  #read
	 sta	  iocb_command

	 jsr	  call_rwts
	 bcs	  ..do_we_read_again

..ck_for_correct_sector
	 lda	  score_sector+(12*8)+0
	 cmp	  #'R'
	 bne	  ..do_we_read_again
	 lda	  score_sector+(12*8)+1
	 cmp	  #'T'
	 bne	  ..do_we_read_again
	 lda	  score_sector+(12*8)+2
	 cmp	  #'U'
	 beq	  ..good_read



..do_we_read_again
	 dec	  ..read_attempts
	 bpl	  ..try_again
	 jmp	  ..set_for_no_score_disk

..try_again

;
; tell the idiot to try the correct disk
;

	 lda	  #08
	 sta	  indent
	 lda	  #11
	 sta	  txtline

	 lda	  #l_bad_disk
	 ldx	  #low bad_disk
	 ldy	  #high bad_disk

	 jsr	  textout

	 lda	  #08
	 sta	  indent
	 lda	  #12
	 sta	  txtline

	 lda	  #l_bd_anykey
	 ldx	  #low bd_anykey
	 ldy	  #high bd_anykey

	 jsr	  textout


..wait_for_a_key
	 long	  secprm,stick_vector
	 cpx	  #$00
	 bne	  ..go_for_another
	 cmp	  #$00
	 beq	  ..wait_for_a_key

..go_for_another
	 jsr	  clrtext

	 jmp	  ..read_scores_from_disk



..set_for_no_score_disk
	 lda	  #$7f
	 sta	  ..scores_flag
	 bne	  ..scores_are_in


..good_read
	 lda	  #$ff
	 sta	  ..scores_flag


..scores_are_in


****************************************






;
;
; print text on the screen
;
;


	 lda	  #..number_of_items-1
	 sta	  temp1

..printlp
	 lda	  temp1
	 tax

	 lda	  ..stx,x
	 sta	  indent
	 lda	  ..sty,x
	 sta	  txtline
	 lda	  ..stlen,x
	 pha

	 txa
	 asl	  a
	 tax

	 ldy	  ..stadr+1,x
	 lda	  ..stadr,x
	 tax
	 pla

	 jsr	  textout

	 dec	  temp1
	 bpl	  ..printlp

;
; print the numbers
;
;
;
;
;
; convert total PINs found to ASCII
;
	 dmove	  ..bcd_buff1,..bcd_total_pins
	 jsr	  ..xl82text
	 lda	  #' ' or %10000000
	 sta	  ..ascii_buff

;
; print pins found
;
	 lda	  #21
	 sta	  indent
	 lda	  #02
	 sta	  txtline

	 lda	  #04
	 ldx	  #low(..ascii_buff)
	 ldy	  #high(..ascii_buff)

	 jsr	  textout

;
; print PINs score
;
	 lda	  #31
	 sta	  indent
	 lda	  #02
	 sta	  txtline

	 lda	  #04
	 ldx	  #low(..ascii_buff)
	 ldy	  #high(..ascii_buff)

	 jsr	  textout


;
; print # of objects found
;
	 dmove	  ..bcd_buff1,..bcd_obj_found
	 jsr	  ..xl82text
	 lda	  #' ' or %10000000
	 sta	  ..ascii_buff

	 lda	  #21
	 sta	  indent
	 lda	  #03
	 sta	  txtline

	 lda	  #04
	 ldx	  #low(..ascii_buff)
	 ldy	  #high(..ascii_buff)

	 jsr	  textout

;
; print of objects found score
;
	 dmove	  ..bcd_buff1,..bcd_obj_score
	 jsr	  ..xl82text
	 lda	  #' ' or %10000000
	 sta	  ..ascii_buff

	 lda	  #31
	 sta	  indent
	 lda	  #03
	 sta	  txtline

	 lda	  #04
	 ldx	  #low(..ascii_buff)
	 ldy	  #high(..ascii_buff)

	 jsr	  textout





;
; print # of musics found
;
	 dmove	  ..bcd_buff1,..bcd_music
	 jsr	  ..xl82text
	 lda	  #' ' or %10000000
	 sta	  ..ascii_buff

	 lda	  #21
	 sta	  indent
	 lda	  #04
	 sta	  txtline

	 lda	  #04
	 ldx	  #low(..ascii_buff)
	 ldy	  #high(..ascii_buff)

	 jsr	  textout

;
; print music score
;
	 dmove	  ..bcd_buff1,..bcd_music_score
	 jsr	  ..xl82text
	 lda	  #' ' or %10000000
	 sta	  ..ascii_buff

	 lda	  #31
	 sta	  indent
	 lda	  #04
	 sta	  txtline

	 lda	  #04
	 ldx	  #low(..ascii_buff)
	 ldy	  #high(..ascii_buff)

	 jsr	  textout








;
; print # of towers completed
;
	 dmove	  ..bcd_buff1,..bcd_towrcomp
	 jsr	  ..xl82text
	 lda	  #' ' or %10000000
	 sta	  ..ascii_buff+2

	 lda	  #22
	 sta	  indent
	 lda	  #06
	 sta	  txtline

	 lda	  #02
	 ldx	  #low(..ascii_buff+2)
	 ldy	  #high(..ascii_buff+2)

	 jsr	  textout

;
; print towers score
;
	 dmove	  ..bcd_buff1,..bcd_towers_score
	 jsr	  ..xl82text
	 lda	  #' ' or %10000000
	 sta	  ..ascii_buff

	 lda	  #31
	 sta	  indent
	 lda	  #06
	 sta	  txtline

	 lda	  #04
	 ldx	  #low(..ascii_buff)
	 ldy	  #high(..ascii_buff)

	 jsr	  textout






;
; print time remaining
;
	 dmove	  ..bcd_buff1,timer+1
	 jsr	  ..xl82text

	 dmove	  time_mask+3,..ascii_buff
	 dmove	  time_mask+6,..ascii_buff+2

	 dmove	  ..bcd_buff1,timer+2
	 jsr	  ..xl82text

	 move	  time_mask+1,..ascii_buff+1

	 lda	  #21
	 sta	  indent
	 lda	  #08
	 sta	  txtline

	 lda	  #10
	 ldx	  #low(time_mask)
	 ldy	  #high(time_mask)

	 jsr	  textout

;
; print the time score
;
	 dmove	  ..bcd_buff1,..bcd_time_score
	 jsr	  ..xl82text

	 lda	  #33
	 sta	  indent
	 lda	  #08
	 sta	  txtline

	 lda	  #04
	 ldx	  #low(..ascii_buff)
	 ldy	  #high(..ascii_buff)

	 jsr	  textout

	 dmove	  ..bcd_buff1,..bcd_time_score+1
	 jsr	  ..xl82text

	 lda	  #32
	 sta	  indent
	 lda	  #08
	 sta	  txtline

	 lda	  #01
	 ldx	  #low(..ascii_buff+1)
	 ldy	  #high(..ascii_buff+1)

	 jsr	  textout



;
; print the total score
;
	 dmove	  ..bcd_buff1,..bcd_total_score
	 jsr	  ..xl82text

	 lda	  #33
	 sta	  indent
	 lda	  #12
	 sta	  txtline

	 lda	  #04
	 ldx	  #low(..ascii_buff)
	 ldy	  #high(..ascii_buff)

	 jsr	  textout

	 dmove	  ..bcd_buff1,..bcd_total_score+1
	 jsr	  ..xl82text

	 lda	  #31
	 sta	  indent
	 lda	  #12
	 sta	  txtline

	 lda	  #02
	 ldx	  #low(..ascii_buff)
	 ldy	  #high(..ascii_buff)

	 jsr	  textout





;
; check for a new high score
;

	 bit	  ..scores_flag
	 lbpl	  ..exit

	 lda	  #00
	 sta	  temp1

	 sed

..ck_for_new_high_loop
	 lda	  temp1
	 asl	  a
	 asl	  a
	 asl	  a
	 tax

	 sec

	 lda	  score_sector,x
	 sbc	  ..bcd_total_score
	 lda	  score_sector+1,x
	 sbc	  ..bcd_total_score+1
	 lda	  score_sector+2,x
	 sbc	  ..bcd_total_score+2
	 bmi	  ..found_a_new_high_score

	 inc	  temp1
	 lda	  temp1
	 cmp	  #12
	 bcc	  ..ck_for_new_high_loop
	 bcs	  ..just_display_high_scores

..found_a_new_high_score
	 cld

	 lda	  temp1
	 asl	  a
	 asl	  a
	 asl	  a

	 clc
	 adc	  #low score_sector
	 sta	  tdbl1
	 lda	  #$00
	 adc	  #high score_sector
	 sta	  tdbl1+1

	 clc
	 lda	  tdbl1
	 adc	  #$08
	 sta	  tdbl2
	 lda	  tdbl1+1
	 adc	  #$00
	 sta	  tdbl2+1


	 lda	  #11
	 sec
	 sbc	  temp1
	 asl	  a
	 asl	  a
	 asl	  a
	 tay
	 dey

..move_lower_scores
	 lda	  (tdbl1),y
	 sta	  (tdbl2),y
	 dey
	 bpl	  ..move_lower_scores


	 lda	  temp1
	 asl	  a
	 asl	  a
	 asl	  a
	 tax

	 lda	  ..bcd_total_score+0
	 sta	  score_sector+0,x
	 lda	  ..bcd_total_score+1
	 sta	  score_sector+1,x
	 lda	  ..bcd_total_score+2
	 sta	  score_sector+2,x

	 lda	  #'.'
	 sta	  score_sector+3,x
	 sta	  score_sector+4,x
	 sta	  score_sector+5,x
	 sta	  score_sector+6,x
	 sta	  score_sector+7,x

	 cld
	 jsr	  ..print_high_scores

	 jsr	  enter_name


;
; write new high scores to disk
;
	 lda	  #low score_sector
	 sta	  iocb_io_buff_pntr
	 lda	  #high score_sector
	 sta	  iocb_io_buff_pntr+1

	 lda	  #$22
	 sta	  iocb_track
	 lda	  #$0f
	 sta	  iocb_sector

	 lda	  #write
	 sta	  iocb_command

	 jsr	  call_rwts


..just_display_high_scores
	 cld

	 jsr	  ..print_high_scores


..exit
	 cld

..wait_for_no_key_pressed
	 long	  secprm,stick_vector
	 cpx	  #$00
	 bne	  ..wait_for_no_key_pressed
	 cmp	  #$00
	 bne	  ..wait_for_no_key_pressed


	 ldy	  #$00
..dumwtlp1
	 ldx	  #$00
..dumwtlp
	 jsr	  ..dumwt
	 dex
	 bne	  ..dumwtlp
	 dey
	 bne	  ..dumwtlp1

	 lda	  #03
	 sta	  indent
	 lda	  #15
	 sta	  txtline

	 lda	  #l_any_key
	 ldx	  #low any_key
	 ldy	  #high any_key

	 jsr	  textout

..wait_for_user
	 long	  secprm,stick_vector
	 cpx	  #$00
	 bne	  ..the_very_end_at_last
	 cmp	  #$00
	 beq	  ..wait_for_user

..the_very_end_at_last
	 sta	  rd_main
	 sta	  wr_main
	 jmp	  init

..dumwt
	 jsr	  $+3
	 jsr	  $+3
	 jsr	  $+3
	 rts


*****************************************
..print_high_scores
	 cld

	 lda	  #$00
	 sta	  temp2

..print_scores_loop
	 cld

	 lda	  temp2
	 cmp	  #06
	 bcc	  ..column1

	 clc
	 adc	  #11
	 sta	  txtline

	 lda	  #25
	 bne	  ..do_digits

..column1
	 clc
	 adc	  #17
	 sta	  txtline

	 lda	  #11

..do_digits
	 sta	  ..xoffset


	 lda	  temp2
	 asl	  a
	 asl	  a
	 asl	  a
	 tax

	 lda	  score_sector+0,x
	 sta	  ..bcd_buff1+0
	 lda	  score_sector+1,x
	 sta	  ..bcd_buff1+1


	 jsr	  ..xl82text

	 ldy	  ..xoffset
	 iny
	 iny
	 sty	  indent

	 lda	  #04
	 ldx	  #low(..ascii_buff)
	 ldy	  #high(..ascii_buff)

	 cld

	 jsr	  textout



	 lda	  temp2
	 asl	  a
	 asl	  a
	 asl	  a
	 tax

	 lda	  score_sector+1,x
	 sta	  ..bcd_buff1+0
	 lda	  score_sector+2,x
	 sta	  ..bcd_buff1+1

	 jsr	  ..xl82text

	 lda	  ..xoffset
	 sta	  indent

	 lda	  #02
	 ldx	  #low(..ascii_buff)
	 ldy	  #high(..ascii_buff)

	 cld

	 jsr	  textout


;
; print "names"
;

	 lda	  ..xoffset
	 clc
	 adc	  #7
	 sta	  indent

	 lda	  temp2
	 asl	  a
	 asl	  a
	 asl	  a
	 tax

	 lda	  score_sector+0+3,x
	 sta	  ..ascii_buff+0
	 lda	  score_sector+1+3,x
	 sta	  ..ascii_buff+1
	 lda	  score_sector+2+3,x
	 sta	  ..ascii_buff+2
	 lda	  score_sector+3+3,x
	 sta	  ..ascii_buff+3
	 lda	  score_sector+4+3,x
	 sta	  ..ascii_buff+4


	 lda	  #05
	 ldx	  #low(..ascii_buff)
	 ldy	  #high(..ascii_buff)

	 jsr	  textout


	 inc	  temp2
	 lda	  temp2
	 cmp	  #12
	 bcs	  ..exit_print_scores
	 jmp	  ..print_scores_loop

..exit_print_scores
	 rts



*****************************************
..xl82text
;
; convert 16 bit bcd to ascii
;
; bcd is passed in "..bcd_buff1"
;
; ascii passed back in "..ascii_buff"
;
	 lda	  ..bcd_buff1
	 and	  #$0f
	 tax
	 lda	  ..ascii_tab,x
	 sta	  ..ascii_buff+3

	 lda	  ..bcd_buff1
	 lsr	  a
	 lsr	  a
	 lsr	  a
	 lsr	  a
	 tax
	 lda	  ..ascii_tab,x
	 sta	  ..ascii_buff+2

	 lda	  ..bcd_buff1+1
	 and	  #$0f
	 tax
	 lda	  ..ascii_tab,x
	 sta	  ..ascii_buff+1

	 lda	  ..bcd_buff1+1
	 lsr	  a
	 lsr	  a
	 lsr	  a
	 lsr	  a
	 tax
	 lda	  ..ascii_tab,x
	 sta	  ..ascii_buff+0

	 rts

..ascii_tab
	 db	  "0123456789ABCDEF"	     ; A-F for good measure
..ascii_buff
	 ds	  5


*****************************************
..xsixtydec
;
; bcd * 60 routine.
; number passed & returned in "..bcd_buff1"
;
	 dmove	  ..bcd_buff2,..bcd_buff1
	 move	  ..bcd_buff2+2,..bcd_buff1+2

	 sed

	 ldx	  #$04
..xsixtylp
	 clc
	 lda	  ..bcd_buff1
	 adc	  ..bcd_buff2
	 sta	  ..bcd_buff1
	 lda	  ..bcd_buff1+1
	 adc	  ..bcd_buff2+1
	 sta	  ..bcd_buff1+1
	 lda	  ..bcd_buff1+2
	 adc	  ..bcd_buff2+2
	 sta	  ..bcd_buff1+2
	 dex
	 bpl	  ..xsixtylp

	 cld

	 ldx	  #$03
..xtenlp
	 asl	  ..bcd_buff1
	 rol	  ..bcd_buff1+1
	 rol	  ..bcd_buff1+2
	 dex
	 bpl	  ..xtenlp

	 rts


*****************************************************************

	 public   enter_name
enter_name
;
; temp1 contains the entry number of the new high score
;

NUL	 equ	  $00
BS	 equ	  $08
CR	 equ	  $0d
DEL	 equ	  $7f

	 sta	  rd_main
	 sta	  wr_main


	 cld

	 lda	  #03
	 sta	  indent
	 lda	  #15
	 sta	  txtline

	 lda	  #l_new_name
	 ldx	  #low new_name
	 ldy	  #high new_name

	 jsr	  textout

	 lda	  temp1
	 asl	  a
	 asl	  a
	 asl	  a
	 clc
	 adc	  #$03
	 adc	  #low score_sector
	 sta	  tdbl2
	 lda	  #$00
	 adc	  #high score_sector
	 sta	  tdbl2+1

	 dmove	  ..name_addr,tdbl2

	 ldy	  #$04
..move_name_loop
	 lda	  (tdbl2),y
	 sta	  ..ascii_buffer,y
	 dey
	 bpl	  ..move_name_loop

	 ldx	  #$00
	 stx	  ..cur_pos

	 jsr	  ..set_cursor_ptr

	 ldx	  temp1
	 lda	  ..ascii_buffer,x
	 and	  #%00111111
	 ora	  #%01000000
	 sta	  (tdbl1),y

	 lda	  $c010

..wait_for_input
	 long	  secprm,stick_vector
	 cpx	  ..last_key
	 beq	  ..wait_for_input
	 stx	  ..last_key

	 cpx	  #NUL
	 beq	  ..wait_for_input

	 cpx	  #CR
	 beq	  ..done_entering_name

..check_for_BS
	 cpx	  #BS
	 bne	  ..check_for_DEL

	 ldx	  ..cur_pos
	 beq	  ..wait_for_input

	 jsr	  ..set_cursor_ptr

	 lda	  ..ascii_buffer,x
	 sta	  (tdbl1),y

	 dex
	 stx	  ..cur_pos

	 jsr	  ..set_cursor_ptr

	 lda	  ..ascii_buffer,x
	 and	  #%00111111
	 ora	  #%01000000
	 sta	  (tdbl1),y

	 bpl	  ..wait_for_input


..check_for_DEL
	 cpx	  #DEL
	 bne	  ..process_other_keys

	 jsr	  ..set_cursor_ptr

	 ldx	  ..cur_pos
	 lda	  ..ascii_buffer,x
	 ora	  #$80
	 sta	  (tdbl1),y

	 cpx	  #$00
	 beq	  ..dont_dec_cursor
	 dex
	 stx	  ..cur_pos

..dont_dec_cursor
	 jsr	  ..set_cursor_ptr

	 lda	  #$a0
	 sta	  ..ascii_buffer,x
	 and	  #%00111111
	 ora	  #%01000000
	 sta	  (tdbl1),y

	 bpl	  ..wait_for_input


..process_other_keys
	 jsr	  ..set_cursor_ptr

	 txa
	 and	  #%00111111
	 ora	  #%10000000
	 ldx	  ..cur_pos
	 sta	  ..ascii_buffer,x
	 sta	  (tdbl1),y

	 cpx	  #$04
	 bcs	  ..flash_cursor
	 inx
	 stx	  ..cur_pos
	 iny
	 lda	  ..ascii_buffer,x

..flash_cursor
	 and	  #%00111111
	 ora	  #%01000000
	 sta	  (tdbl1),y

	 jmp	  ..wait_for_input











..done_entering_name
	 dmove	  tdbl2,..name_addr

	 ldy	  #$04
..move_name_loop2
	 lda	  ..ascii_buffer,y
	 sta	  (tdbl2),y
	 dey
	 bpl	  ..move_name_loop2

	 rts









..set_cursor_ptr
	 ldy	  temp1
	 lda	  ..name_y,y
	 asl	  a
	 asl	  a
	 asl	  a
	 tay

	 sta	  rd_aux

	 lda	  scanlo,y
	 sta	  tdbl1
	 lda	  scanhi,y
	 ora	  #$04
	 sta	  tdbl1+1

	 sta	  rd_main

	 ldy	  temp1
	 lda	  ..name_x,y
	 clc
	 adc	  ..cur_pos
	 tay

	 rts






*****************************************************************


..stadr  dw	  pins_f,obj_f,mus_f,tow_com,time_rem,yo_sco
	 dw	  xkilo,xcent1,xcent2,xcent3,zz,zz,zz,zz

..stlen  db	  l_pins_f,l_obj_f,l_mus_f,l_tow_com,l_time_rem,l_yo_sco
	 db	  l_xkilo,l_xcent1,l_xcent2,l_xcent3
	 db	  l_zz,l_zz,l_zz,l_zz

..stx	 db	  3,3,3,3,3,3,24,25,25,25,35,35,35,35
..sty	 db	  2,3,4,6,8,12,6,2,3,4,2,3,4,6
..number_of_items equ	   $-..sty

pins_f	 db	  "PINs found"
l_pins_f equ	  $-pins_f

obj_f	 db	  "Objects found"
l_obj_f  equ	  $-obj_f

mus_f	 db	  "Musics found"
l_mus_f  equ	  $-mus_f

tow_com  db	  "Towers completed"
l_tow_com	  equ	   $-tow_com

time_rem db	  "Time remaining"
l_time_rem	  equ	   $-time_rem

yo_sco	 db	  "Your score"
l_yo_sco equ	  $-yo_sco

xkilo	 db	  "x2000 >"
l_xkilo  equ	  $-xkilo

xcent1	 db	  "x100 >"
l_xcent1 equ	  $-xcent1

xcent2	 db	  "x200 >"
l_xcent2 equ	  $-xcent2

xcent3	 db	  "x300 >"
l_xcent3 equ	  $-xcent3

zz	 db	  "00"
l_zz	 equ	  $-zz

time_mask	  db	   " 0:00:00 >"

..name_x db	  18,18,18,18,18,18,32,32,32,32,32,32
..name_y db	  17,18,19,20,21,22,17,18,19,20,21,22
..cur_pos ds	   1
..name_addr	  dw	   $ffff
..last_key	  ds	   1





;
; the next 2 messages appear at (3,15)
;

any_key  db	  "Press any key to restart"
l_any_key	  equ	   $-any_key

new_name db	  "Please enter your name  "
l_new_name	  equ	   $-new_name






bad_disk db	  "Please insert IM2 side 2"
l_bad_disk	  equ	   $-bad_disk

bd_anykey db	  "and press any key."
l_bd_anykey	  equ	   $-bd_anykey




..bcd_total_score ds	   3
..bcd_total_pins  ds	   2
..bcd_obj_found   ds	   2
..bcd_obj_score   ds	   2
..bcd_music	  ds	   2
..bcd_music_score ds	   2
..bcd_towrcomp	  ds	   2
..bcd_towers_score	   ds	    2
..bcd_time_score  ds	   3
..bcd_buff1	  ds	   3
..bcd_buff2	  ds	   3
..ascii_buffer	  ds	   5
..xoffset	  ds	   1
..scores_flag	  db	   $7f
..read_attempts   ds	   1
score_sector	  ds	   $0100

score_screen	    endproc



hexdec	PROC

	sed
	lda	#0
	sta	decimal
	sta	decimal+1

	ldx	#0

..loop	ror	hex+1
	ror	hex
	bcc	..nx

	lda	decimal
	clc
	adc	..dadd,x
	sta	decimal
	lda	decimal+1
	adc	..dadd+1,x
	sta	decimal+1

..nx	inx
	inx
	cpx	#30
	bcc	..loop
	cld
	rts

..dadd	dw	$0001
	dw	$0002
	dw	$0004
	dw	$0008
	dw	$0016
	dw	$0032
	dw	$0064
	dw	$0128
	dw	$0256
	dw	$0512
	dw	$1024
	dw	$2048
	dw	$4096
	dw	$8192

decimal  ds	  2
hex	 ds	  2

hexdec	ENDPROC


	 end
